//Generated code

part of 'bookmark_service.swagger.dart';

// **************************************************************************
// ChopperGenerator
// **************************************************************************

// ignore_for_file: always_put_control_body_on_new_line, always_specify_types, prefer_const_declarations, unnecessary_brace_in_string_interps
class _$BookmarkService extends BookmarkService {
  _$BookmarkService([ChopperClient? client]) {
    if (client == null) return;
    this.client = client;
  }

  @override
  final definitionType = BookmarkService;

  @override
  Future<Response<LatestBookmarkView>> _latestProfileIdContentIdGet({
    String? xCus = 'X-Cus',
    required String? profileId,
    required String? contentId,
    String? contentType,
    String? cacheControl,
  }) {
    final Uri $url = Uri.parse('/latest/${profileId}/${contentId}');
    final Map<String, dynamic> $params = <String, dynamic>{
      'contentType': contentType
    };
    final Map<String, String> $headers = {
      if (xCus != null) 'X-Cus': xCus,
      if (cacheControl != null) 'Cache-Control': cacheControl,
    };
    final Request $request = Request(
      'GET',
      $url,
      client.baseUrl,
      parameters: $params,
      headers: $headers,
    );
    return client.send<LatestBookmarkView, LatestBookmarkView>($request);
  }

  @override
  Future<Response<List<Bookmark>>> _profilesProfileIdBookmarksGet({
    String? xCus = 'X-Cus',
    required String? profileId,
    String? contentType,
    String? ifModifiedSince,
    String? xBMSExplicitLogging,
    String? cacheControl,
  }) {
    final Uri $url = Uri.parse('/profiles/${profileId}/bookmarks');
    final Map<String, dynamic> $params = <String, dynamic>{
      'contentType': contentType
    };
    final Map<String, String> $headers = {
      if (xCus != null) 'X-Cus': xCus,
      if (ifModifiedSince != null) 'If-Modified-Since': ifModifiedSince,
      if (xBMSExplicitLogging != null)
        'X-BMS-Explicit-Logging': xBMSExplicitLogging,
      if (cacheControl != null) 'Cache-Control': cacheControl,
    };
    final Request $request = Request(
      'GET',
      $url,
      client.baseUrl,
      parameters: $params,
      headers: $headers,
    );
    return client.send<List<Bookmark>, Bookmark>($request);
  }

  @override
  Future<Response<dynamic>> _profilesProfileIdBookmarksDelete({
    String? xCus = 'X-Cus',
    required String? profileId,
    String? cacheControl,
  }) {
    final Uri $url = Uri.parse('/profiles/${profileId}/bookmarks');
    final Map<String, String> $headers = {
      if (xCus != null) 'X-Cus': xCus,
      if (cacheControl != null) 'Cache-Control': cacheControl,
    };
    final Request $request = Request(
      'DELETE',
      $url,
      client.baseUrl,
      headers: $headers,
    );
    return client.send<dynamic, dynamic>($request);
  }

  @override
  Future<Response<dynamic>> _profilesProfileIdBookmarksContentIdPut({
    required String? profileId,
    required String? contentId,
    String? xCus = 'X-Cus',
    String? xDev,
    String? xBMSExplicitLogging,
    String? xGoDev,
    String? cacheControl,
    required BookmarkParams? body,
  }) {
    final Uri $url = Uri.parse('/profiles/${profileId}/bookmarks/${contentId}');
    final Map<String, String> $headers = {
      if (xCus != null) 'X-Cus': xCus,
      if (xDev != null) 'X-Dev': xDev,
      if (xBMSExplicitLogging != null)
        'X-BMS-Explicit-Logging': xBMSExplicitLogging,
      if (xGoDev != null) 'X-Go-Dev': xGoDev,
      if (cacheControl != null) 'Cache-Control': cacheControl,
    };
    final $body = body;
    final Request $request = Request(
      'PUT',
      $url,
      client.baseUrl,
      body: $body,
      headers: $headers,
    );
    return client.send<dynamic, dynamic>($request);
  }

  @override
  Future<Response<BookmarksExist>> _profilesProfileIdBookmarksExistPost({
    String? xCus = 'X-Cus',
    String? xDev,
    String? xBMSExplicitLogging,
    required String? profileId,
    String? cacheControl,
    required CheckBookmarksExist? body,
  }) {
    final Uri $url = Uri.parse('/profiles/${profileId}/bookmarks/exist');
    final Map<String, String> $headers = {
      if (xCus != null) 'X-Cus': xCus,
      if (xDev != null) 'X-Dev': xDev,
      if (xBMSExplicitLogging != null)
        'X-BMS-Explicit-Logging': xBMSExplicitLogging,
      if (cacheControl != null) 'Cache-Control': cacheControl,
    };
    final $body = body;
    final Request $request = Request(
      'POST',
      $url,
      client.baseUrl,
      body: $body,
      headers: $headers,
    );
    return client.send<BookmarksExist, BookmarksExist>($request);
  }

  @override
  Future<Response<List<ContinueWatchingItem>>>
      _profilesProfileIdContinueWatchingGet({
    required String? profileId,
    List<String>? contentTypes,
    int? limit,
    String? xBMSExplicitLogging,
    String? cacheControl,
  }) {
    final Uri $url = Uri.parse('/profiles/${profileId}/continue-watching');
    final Map<String, dynamic> $params = <String, dynamic>{
      'contentTypes': contentTypes,
      'limit': limit,
    };
    final Map<String, String> $headers = {
      if (xBMSExplicitLogging != null)
        'X-BMS-Explicit-Logging': xBMSExplicitLogging,
      if (cacheControl != null) 'Cache-Control': cacheControl,
    };
    final Request $request = Request(
      'GET',
      $url,
      client.baseUrl,
      parameters: $params,
      headers: $headers,
    );
    return client
        .send<List<ContinueWatchingItem>, ContinueWatchingItem>($request);
  }

  @override
  Future<Response<dynamic>> _profilesProfileIdContinueWatchingDeletePost({
    String? xCus = 'X-Cus',
    required String? profileId,
    String? xBMSExplicitLogging,
    String? cacheControl,
    required ContinueWatchingDeleteParams? body,
  }) {
    final Uri $url =
        Uri.parse('/profiles/${profileId}/continue-watching/delete');
    final Map<String, String> $headers = {
      if (xCus != null) 'X-Cus': xCus,
      if (xBMSExplicitLogging != null)
        'X-BMS-Explicit-Logging': xBMSExplicitLogging,
      if (cacheControl != null) 'Cache-Control': cacheControl,
    };
    final $body = body;
    final Request $request = Request(
      'POST',
      $url,
      client.baseUrl,
      body: $body,
      headers: $headers,
    );
    return client.send<dynamic, dynamic>($request);
  }

  @override
  Future<Response<dynamic>> _customersCustomerIdBookmarksDelete({
    required String? customerId,
    String? xBMSExplicitLogging,
    String? cacheControl,
  }) {
    final Uri $url = Uri.parse('/customers/${customerId}/bookmarks');
    final Map<String, String> $headers = {
      if (xBMSExplicitLogging != null)
        'X-BMS-Explicit-Logging': xBMSExplicitLogging,
      if (cacheControl != null) 'Cache-Control': cacheControl,
    };
    final Request $request = Request(
      'DELETE',
      $url,
      client.baseUrl,
      headers: $headers,
    );
    return client.send<dynamic, dynamic>($request);
  }

  @override
  Future<Response<dynamic>> _customersCustomerIdProfilesProfileIdBookmarksPut({
    required String? customerId,
    required String? profileId,
    String? xCus = 'X-Cus',
    String? cacheControl,
    required List<BulkBookmarkParams>? body,
  }) {
    final Uri $url =
        Uri.parse('/customers/${customerId}/profiles/${profileId}/bookmarks');
    final Map<String, String> $headers = {
      if (xCus != null) 'X-Cus': xCus,
      if (cacheControl != null) 'Cache-Control': cacheControl,
    };
    final $body = body;
    final Request $request = Request(
      'PUT',
      $url,
      client.baseUrl,
      body: $body,
      headers: $headers,
    );
    return client.send<dynamic, dynamic>($request);
  }

  @override
  Future<Response<dynamic>> _v1CustomersMigratePost({
    String? cacheControl,
    required MigrateCustomerParam? body,
  }) {
    final Uri $url = Uri.parse('/v1/customers/migrate');
    final Map<String, String> $headers = {
      if (cacheControl != null) 'Cache-Control': cacheControl,
    };
    final $body = body;
    final Request $request = Request(
      'POST',
      $url,
      client.baseUrl,
      body: $body,
      headers: $headers,
    );
    return client.send<dynamic, dynamic>($request);
  }

  @override
  Future<Response<List<BookmarkAdvanced>>> _bookmarksSearchPost({
    String? xCus = 'X-Cus',
    String? ifModifiedSince,
    String? xBMSExplicitLogging,
    String? cacheControl,
    required BookmarkSearchFilter? body,
  }) {
    final Uri $url = Uri.parse('/bookmarks/search');
    final Map<String, String> $headers = {
      if (xCus != null) 'X-Cus': xCus,
      if (ifModifiedSince != null) 'If-Modified-Since': ifModifiedSince,
      if (xBMSExplicitLogging != null)
        'X-BMS-Explicit-Logging': xBMSExplicitLogging,
      if (cacheControl != null) 'Cache-Control': cacheControl,
    };
    final $body = body;
    final Request $request = Request(
      'POST',
      $url,
      client.baseUrl,
      body: $body,
      headers: $headers,
    );
    return client.send<List<BookmarkAdvanced>, BookmarkAdvanced>($request);
  }

  @override
  Future<Response<dynamic>> _bookmarksContentTypeContentIdDelete({
    required String? contentType,
    required String? contentId,
    String? ifModifiedSince,
    String? xBMSExplicitLogging,
    String? cacheControl,
  }) {
    final Uri $url = Uri.parse('/bookmarks/${contentType}/${contentId}');
    final Map<String, String> $headers = {
      if (ifModifiedSince != null) 'If-Modified-Since': ifModifiedSince,
      if (xBMSExplicitLogging != null)
        'X-BMS-Explicit-Logging': xBMSExplicitLogging,
      if (cacheControl != null) 'Cache-Control': cacheControl,
    };
    final Request $request = Request(
      'DELETE',
      $url,
      client.baseUrl,
      headers: $headers,
    );
    return client.send<dynamic, dynamic>($request);
  }

  @override
  Future<Response<List<BookmarkAdvancedV2>>> _v2BookmarksSearchPost({
    String? xCus = 'X-Cus',
    String? ifModifiedSince,
    String? xBMSExplicitLogging,
    String? cacheControl,
    required BookmarkSearchFilterV2? body,
  }) {
    final Uri $url = Uri.parse('/v2/bookmarks/search');
    final Map<String, String> $headers = {
      if (xCus != null) 'X-Cus': xCus,
      if (ifModifiedSince != null) 'If-Modified-Since': ifModifiedSince,
      if (xBMSExplicitLogging != null)
        'X-BMS-Explicit-Logging': xBMSExplicitLogging,
      if (cacheControl != null) 'Cache-Control': cacheControl,
    };
    final $body = body;
    final Request $request = Request(
      'POST',
      $url,
      client.baseUrl,
      body: $body,
      headers: $headers,
    );
    return client.send<List<BookmarkAdvancedV2>, BookmarkAdvancedV2>($request);
  }
}
