import 'package:json_annotation/json_annotation.dart';
import 'package:collection/collection.dart';

enum ChannelResolution {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('SD')
  sd('SD'),
  @JsonValue('HD')
  hd('HD'),
  @JsonValue('4K')
  value_4k('4K'),
  @JsonValue('5K')
  value_5k('5K'),
  @JsonValue('8K')
  value_8k('8K');

  final String? value;

  const ChannelResolution(this.value);
}

enum ChannelReplayMode {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('EXACT')
  exact('EXACT'),
  @JsonValue('VOSDAL')
  vosdal('VOSDAL');

  final String? value;

  const ChannelReplayMode(this.value);
}

enum ChannelTrickPlayControl {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('disallowFastForward')
  disallowfastforward('disallowFastForward'),
  @JsonValue('disallowPause')
  disallowpause('disallowPause'),
  @JsonValue('disallowPlay')
  disallowplay('disallowPlay'),
  @JsonValue('disallowRewind')
  disallowrewind('disallowRewind'),
  @JsonValue('disallowSkipForward')
  disallowskipforward('disallowSkipForward'),
  @JsonValue('disallowSkipBackward')
  disallowskipbackward('disallowSkipBackward'),
  @JsonValue('adRestrictionOnly')
  adrestrictiononly('adRestrictionOnly');

  final String? value;

  const ChannelTrickPlayControl(this.value);
}

enum ChannelReplaySources {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('buffer')
  buffer('buffer'),
  @JsonValue('vod')
  vod('vod'),
  @JsonValue('app')
  app('app');

  final String? value;

  const ChannelReplaySources(this.value);
}

enum ChannelContextMenuActions {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('replayCatalog')
  replaycatalog('replayCatalog');

  final String? value;

  const ChannelContextMenuActions(this.value);
}

enum BoundAppTrigger {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('RED')
  red('RED'),
  @JsonValue('GREEN')
  green('GREEN'),
  @JsonValue('YELLOW')
  yellow('YELLOW'),
  @JsonValue('BLUE')
  blue('BLUE'),
  @JsonValue('IMMEDIATE')
  immediate('IMMEDIATE'),
  @JsonValue('AUTOSTART')
  autostart('AUTOSTART'),
  @JsonValue('AUTOSTART_VIRTUALCH')
  autostartVirtualch('AUTOSTART_VIRTUALCH'),
  @JsonValue('OK')
  ok('OK');

  final String? value;

  const BoundAppTrigger(this.value);
}

enum ChannelListType {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('USER')
  user('USER'),
  @JsonValue('LOCKED')
  locked('LOCKED'),
  @JsonValue('FAVORITE')
  favorite('FAVORITE');

  final String? value;

  const ChannelListType(this.value);
}

enum CurrentChannelListType {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('USER')
  user('USER'),
  @JsonValue('FAVORITE')
  favorite('FAVORITE');

  final String? value;

  const CurrentChannelListType(this.value);
}
