import 'package:json_annotation/json_annotation.dart';
import 'package:collection/collection.dart';

enum ContentRequestType {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('CHANNEL')
  channel('CHANNEL'),
  @JsonValue('PROVIDER')
  provider('PROVIDER');

  final String? value;

  const ContentRequestType(this.value);
}

enum IntentResourceIdImageTypeGetMode {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('stretch')
  stretch('stretch'),
  @JsonValue('box')
  box('box'),
  @JsonValue('crop')
  crop('crop'),
  @JsonValue('fill')
  fill('fill'),
  @JsonValue('fill-NorthWest')
  fillNorthwest('fill-NorthWest'),
  @JsonValue('fill-North')
  fillNorth('fill-North'),
  @JsonValue('fill-NorthEast')
  fillNortheast('fill-NorthEast'),
  @JsonValue('fill-West')
  fillWest('fill-West'),
  @JsonValue('fill-Center')
  fillCenter('fill-Center'),
  @JsonValue('fill-East')
  fillEast('fill-East'),
  @JsonValue('fill-SouthWest')
  fillSouthwest('fill-SouthWest'),
  @JsonValue('fill-South')
  fillSouth('fill-South'),
  @JsonValue('fill-SouthEast')
  fillSoutheast('fill-SouthEast');

  final String? value;

  const IntentResourceIdImageTypeGetMode(this.value);
}

enum IntentResourceIdImageTypeGetFormat {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('jpg')
  jpg('jpg'),
  @JsonValue('jpeg')
  jpeg('jpeg'),
  @JsonValue('png')
  png('png'),
  @JsonValue('webp')
  webp('webp'),
  @JsonValue('jp2')
  jp2('jp2'),
  @JsonValue('jxr')
  jxr('jxr');

  final String? value;

  const IntentResourceIdImageTypeGetFormat(this.value);
}

enum IntentResourceIdImageTypeGetChannel {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('Red')
  red('Red'),
  @JsonValue('Green')
  green('Green'),
  @JsonValue('Blue')
  blue('Blue'),
  @JsonValue('Opacity')
  opacity('Opacity'),
  @JsonValue('Gray')
  gray('Gray');

  final String? value;

  const IntentResourceIdImageTypeGetChannel(this.value);
}

enum IntentResourceIdImageTypeGetColorSpace {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('CMY')
  cmy('CMY'),
  @JsonValue('CMYK')
  cmyk('CMYK'),
  @JsonValue('Gray')
  gray('Gray'),
  @JsonValue('HCL')
  hcl('HCL'),
  @JsonValue('HCLp')
  hclp('HCLp'),
  @JsonValue('HSB')
  hsb('HSB'),
  @JsonValue('HSI')
  hsi('HSI'),
  @JsonValue('HSL')
  hsl('HSL'),
  @JsonValue('HSV')
  hsv('HSV'),
  @JsonValue('HWB')
  hwb('HWB'),
  @JsonValue('Lab')
  lab('Lab'),
  @JsonValue('LCHab')
  lchab('LCHab'),
  @JsonValue('LCHuv')
  lchuv('LCHuv'),
  @JsonValue('LMS')
  lms('LMS'),
  @JsonValue('Log')
  log('Log'),
  @JsonValue('Luv')
  luv('Luv'),
  @JsonValue('OHTA')
  ohta('OHTA'),
  @JsonValue('Rec601YCbCr')
  rec601ycbcr('Rec601YCbCr'),
  @JsonValue('Rec709YCbCr')
  rec709ycbcr('Rec709YCbCr'),
  @JsonValue('RGB')
  rgb('RGB'),
  @JsonValue('scRGB')
  scrgb('scRGB'),
  @JsonValue('sRGB')
  srgb('sRGB'),
  @JsonValue('Transparent')
  transparent('Transparent'),
  @JsonValue('xyY')
  xyy('xyY'),
  @JsonValue('XYZ')
  xyz('XYZ'),
  @JsonValue('YCbCr')
  ycbcr('YCbCr'),
  @JsonValue('YCC')
  ycc('YCC'),
  @JsonValue('YDbDr')
  ydbdr('YDbDr'),
  @JsonValue('YIQ')
  yiq('YIQ'),
  @JsonValue('YPbPr')
  ypbpr('YPbPr'),
  @JsonValue('YUV')
  yuv('YUV');

  final String? value;

  const IntentResourceIdImageTypeGetColorSpace(this.value);
}

enum IntentResourceIdImageTypeGetType {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('CHANNEL')
  channel('CHANNEL'),
  @JsonValue('PROVIDER')
  provider('PROVIDER');

  final String? value;

  const IntentResourceIdImageTypeGetType(this.value);
}

enum MetadataPathGetMode {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('stretch')
  stretch('stretch'),
  @JsonValue('box')
  box('box'),
  @JsonValue('crop')
  crop('crop'),
  @JsonValue('fill')
  fill('fill'),
  @JsonValue('fill-NorthWest')
  fillNorthwest('fill-NorthWest'),
  @JsonValue('fill-North')
  fillNorth('fill-North'),
  @JsonValue('fill-NorthEast')
  fillNortheast('fill-NorthEast'),
  @JsonValue('fill-West')
  fillWest('fill-West'),
  @JsonValue('fill-Center')
  fillCenter('fill-Center'),
  @JsonValue('fill-East')
  fillEast('fill-East'),
  @JsonValue('fill-SouthWest')
  fillSouthwest('fill-SouthWest'),
  @JsonValue('fill-South')
  fillSouth('fill-South'),
  @JsonValue('fill-SouthEast')
  fillSoutheast('fill-SouthEast');

  final String? value;

  const MetadataPathGetMode(this.value);
}

enum MetadataPathGetFormat {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('jpg')
  jpg('jpg'),
  @JsonValue('jpeg')
  jpeg('jpeg'),
  @JsonValue('png')
  png('png'),
  @JsonValue('webp')
  webp('webp'),
  @JsonValue('jp2')
  jp2('jp2'),
  @JsonValue('jxr')
  jxr('jxr');

  final String? value;

  const MetadataPathGetFormat(this.value);
}

enum MetadataPathGetChannel {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('Red')
  red('Red'),
  @JsonValue('Green')
  green('Green'),
  @JsonValue('Blue')
  blue('Blue'),
  @JsonValue('Opacity')
  opacity('Opacity'),
  @JsonValue('Gray')
  gray('Gray');

  final String? value;

  const MetadataPathGetChannel(this.value);
}

enum MetadataPathGetColorspace {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('CMY')
  cmy('CMY'),
  @JsonValue('CMYK')
  cmyk('CMYK'),
  @JsonValue('Gray')
  gray('Gray'),
  @JsonValue('HCL')
  hcl('HCL'),
  @JsonValue('HCLp')
  hclp('HCLp'),
  @JsonValue('HSB')
  hsb('HSB'),
  @JsonValue('HSI')
  hsi('HSI'),
  @JsonValue('HSL')
  hsl('HSL'),
  @JsonValue('HSV')
  hsv('HSV'),
  @JsonValue('HWB')
  hwb('HWB'),
  @JsonValue('Lab')
  lab('Lab'),
  @JsonValue('LCHab')
  lchab('LCHab'),
  @JsonValue('LCHuv')
  lchuv('LCHuv'),
  @JsonValue('LMS')
  lms('LMS'),
  @JsonValue('Log')
  log('Log'),
  @JsonValue('Luv')
  luv('Luv'),
  @JsonValue('OHTA')
  ohta('OHTA'),
  @JsonValue('Rec601YCbCr')
  rec601ycbcr('Rec601YCbCr'),
  @JsonValue('Rec709YCbCr')
  rec709ycbcr('Rec709YCbCr'),
  @JsonValue('RGB')
  rgb('RGB'),
  @JsonValue('scRGB')
  scrgb('scRGB'),
  @JsonValue('sRGB')
  srgb('sRGB'),
  @JsonValue('Transparent')
  transparent('Transparent'),
  @JsonValue('xyY')
  xyy('xyY'),
  @JsonValue('XYZ')
  xyz('XYZ'),
  @JsonValue('YCbCr')
  ycbcr('YCbCr'),
  @JsonValue('YCC')
  ycc('YCC'),
  @JsonValue('YDbDr')
  ydbdr('YDbDr'),
  @JsonValue('YIQ')
  yiq('YIQ'),
  @JsonValue('YPbPr')
  ypbpr('YPbPr'),
  @JsonValue('YUV')
  yuv('YUV');

  final String? value;

  const MetadataPathGetColorspace(this.value);
}

enum PathGetMode {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('stretch')
  stretch('stretch'),
  @JsonValue('box')
  box('box'),
  @JsonValue('crop')
  crop('crop'),
  @JsonValue('fill')
  fill('fill'),
  @JsonValue('fill-NorthWest')
  fillNorthwest('fill-NorthWest'),
  @JsonValue('fill-North')
  fillNorth('fill-North'),
  @JsonValue('fill-NorthEast')
  fillNortheast('fill-NorthEast'),
  @JsonValue('fill-West')
  fillWest('fill-West'),
  @JsonValue('fill-Center')
  fillCenter('fill-Center'),
  @JsonValue('fill-East')
  fillEast('fill-East'),
  @JsonValue('fill-SouthWest')
  fillSouthwest('fill-SouthWest'),
  @JsonValue('fill-South')
  fillSouth('fill-South'),
  @JsonValue('fill-SouthEast')
  fillSoutheast('fill-SouthEast');

  final String? value;

  const PathGetMode(this.value);
}

enum PathGetFormat {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('jpg')
  jpg('jpg'),
  @JsonValue('jpeg')
  jpeg('jpeg'),
  @JsonValue('png')
  png('png'),
  @JsonValue('webp')
  webp('webp'),
  @JsonValue('jp2')
  jp2('jp2'),
  @JsonValue('jxr')
  jxr('jxr');

  final String? value;

  const PathGetFormat(this.value);
}

enum PathGetChannel {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('Red')
  red('Red'),
  @JsonValue('Green')
  green('Green'),
  @JsonValue('Blue')
  blue('Blue'),
  @JsonValue('Opacity')
  opacity('Opacity'),
  @JsonValue('Gray')
  gray('Gray');

  final String? value;

  const PathGetChannel(this.value);
}

enum PathGetColorspace {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('CMY')
  cmy('CMY'),
  @JsonValue('CMYK')
  cmyk('CMYK'),
  @JsonValue('Gray')
  gray('Gray'),
  @JsonValue('HCL')
  hcl('HCL'),
  @JsonValue('HCLp')
  hclp('HCLp'),
  @JsonValue('HSB')
  hsb('HSB'),
  @JsonValue('HSI')
  hsi('HSI'),
  @JsonValue('HSL')
  hsl('HSL'),
  @JsonValue('HSV')
  hsv('HSV'),
  @JsonValue('HWB')
  hwb('HWB'),
  @JsonValue('Lab')
  lab('Lab'),
  @JsonValue('LCHab')
  lchab('LCHab'),
  @JsonValue('LCHuv')
  lchuv('LCHuv'),
  @JsonValue('LMS')
  lms('LMS'),
  @JsonValue('Log')
  log('Log'),
  @JsonValue('Luv')
  luv('Luv'),
  @JsonValue('OHTA')
  ohta('OHTA'),
  @JsonValue('Rec601YCbCr')
  rec601ycbcr('Rec601YCbCr'),
  @JsonValue('Rec709YCbCr')
  rec709ycbcr('Rec709YCbCr'),
  @JsonValue('RGB')
  rgb('RGB'),
  @JsonValue('scRGB')
  scrgb('scRGB'),
  @JsonValue('sRGB')
  srgb('sRGB'),
  @JsonValue('Transparent')
  transparent('Transparent'),
  @JsonValue('xyY')
  xyy('xyY'),
  @JsonValue('XYZ')
  xyz('XYZ'),
  @JsonValue('YCbCr')
  ycbcr('YCbCr'),
  @JsonValue('YCC')
  ycc('YCC'),
  @JsonValue('YDbDr')
  ydbdr('YDbDr'),
  @JsonValue('YIQ')
  yiq('YIQ'),
  @JsonValue('YPbPr')
  ypbpr('YPbPr'),
  @JsonValue('YUV')
  yuv('YUV');

  final String? value;

  const PathGetColorspace(this.value);
}
