//Generated code

part of 'image_service.swagger.dart';

// **************************************************************************
// ChopperGenerator
// **************************************************************************

// ignore_for_file: always_put_control_body_on_new_line, always_specify_types, prefer_const_declarations, unnecessary_brace_in_string_interps
class _$ImageService extends ImageService {
  _$ImageService([ChopperClient? client]) {
    if (client == null) return;
    this.client = client;
  }

  @override
  final definitionType = ImageService;

  @override
  Future<Response<List<ContentResponse>>> _intentGet({
    required String? jsonBody,
    String? cacheControl,
  }) {
    final Uri $url = Uri.parse('/intent');
    final Map<String, dynamic> $params = <String, dynamic>{
      'jsonBody': jsonBody
    };
    final Map<String, String> $headers = {
      if (cacheControl != null) 'Cache-Control': cacheControl,
    };
    final Request $request = Request(
      'GET',
      $url,
      client.baseUrl,
      parameters: $params,
      headers: $headers,
    );
    return client.send<List<ContentResponse>, ContentResponse>($request);
  }

  @override
  Future<Response<List<ContentResponse>>> _intentPost({
    String? cacheControl,
    required List<ContentRequest>? body,
  }) {
    final Uri $url = Uri.parse('/intent');
    final Map<String, String> $headers = {
      if (cacheControl != null) 'Cache-Control': cacheControl,
    };
    final $body = body;
    final Request $request = Request(
      'POST',
      $url,
      client.baseUrl,
      body: $body,
      headers: $headers,
    );
    return client.send<List<ContentResponse>, ContentResponse>($request);
  }

  @override
  Future<Response<dynamic>> _intentResourceIdImageTypeGet({
    int? width,
    int? height,
    String? mode,
    num? blur,
    int? brightness,
    String? format,
    String? style,
    String? channel,
    String? colorSpace,
    List<String>? overlay,
    bool? metadata,
    num? quality,
    String? stylePlaceholders,
    String? cornerRadius,
    required String? resourceId,
    String? type,
    required String? imageType,
    String? ifNoneMatch,
    String? cacheControl,
  }) {
    final Uri $url = Uri.parse('/intent/${resourceId}/${imageType}');
    final Map<String, dynamic> $params = <String, dynamic>{
      'width': width,
      'height': height,
      'mode': mode,
      'blur': blur,
      'brightness': brightness,
      'format': format,
      'style': style,
      'channel': channel,
      'colorSpace': colorSpace,
      'overlay': overlay,
      'metadata': metadata,
      'quality': quality,
      'stylePlaceholders': stylePlaceholders,
      'cornerRadius': cornerRadius,
      'type': type,
    };
    final Map<String, String> $headers = {
      if (ifNoneMatch != null) 'If-None-Match': ifNoneMatch,
      if (cacheControl != null) 'Cache-Control': cacheControl,
    };
    final Request $request = Request(
      'GET',
      $url,
      client.baseUrl,
      parameters: $params,
      headers: $headers,
    );
    return client.send<dynamic, dynamic>($request);
  }

  @override
  Future<Response<ImageMetadata>> _metadataPathGet({
    required String? path,
    String? ifNoneMatch,
    int? w,
    int? h,
    String? mode,
    num? blur,
    int? brightness,
    String? format,
    String? style,
    String? channel,
    String? colorspace,
    num? quality,
    String? cornerRadius,
    bool? trim,
    num? wedgeWidthPercentage,
    num? wedgeHeightPercentage,
    String? cacheControl,
  }) {
    final Uri $url = Uri.parse('/metadata/${path}');
    final Map<String, dynamic> $params = <String, dynamic>{
      'w': w,
      'h': h,
      'mode': mode,
      'blur': blur,
      'brightness': brightness,
      'format': format,
      'style': style,
      'channel': channel,
      'colorspace': colorspace,
      'quality': quality,
      'cornerRadius': cornerRadius,
      'trim': trim,
      'wedgeWidthPercentage': wedgeWidthPercentage,
      'wedgeHeightPercentage': wedgeHeightPercentage,
    };
    final Map<String, String> $headers = {
      if (ifNoneMatch != null) 'If-None-Match': ifNoneMatch,
      if (cacheControl != null) 'Cache-Control': cacheControl,
    };
    final Request $request = Request(
      'GET',
      $url,
      client.baseUrl,
      parameters: $params,
      headers: $headers,
    );
    return client.send<ImageMetadata, ImageMetadata>($request);
  }

  @override
  Future<Response<MovePaths>> _movePost({
    String? cacheControl,
    required MovePaths? body,
  }) {
    final Uri $url = Uri.parse('/move');
    final Map<String, String> $headers = {
      if (cacheControl != null) 'Cache-Control': cacheControl,
    };
    final $body = body;
    final Request $request = Request(
      'POST',
      $url,
      client.baseUrl,
      body: $body,
      headers: $headers,
    );
    return client.send<MovePaths, MovePaths>($request);
  }

  @override
  Future<Response<List<String>>> _folderPost({
    required String? folder,
    String? cacheControl,
    required MultiRequest body,
  }) {
    final Uri $url = Uri.parse('/${folder}');
    final Map<String, String> $headers = {
      if (cacheControl != null) 'Cache-Control': cacheControl,
    };
    final List<PartValue> $parts = <PartValue>[
      PartValue<MultiRequest>(
        'body',
        body,
      )
    ];
    final Request $request = Request(
      'POST',
      $url,
      client.baseUrl,
      parts: $parts,
      multipart: true,
      headers: $headers,
    );
    return client.send<List<String>, String>($request);
  }

  @override
  Future<Response<List<String>>> _pathGet({
    required String? path,
    String? ifNoneMatch,
    int? w,
    int? h,
    String? mode,
    num? blur,
    int? brightness,
    String? format,
    String? style,
    String? channel,
    String? colorspace,
    List<String>? overlay,
    bool? metadata,
    num? quality,
    String? stylePlaceholders,
    String? cornerRadius,
    bool? trim,
    num? wedgeWidthPercentage,
    num? wedgeHeightPercentage,
    String? cacheControl,
  }) {
    final Uri $url = Uri.parse('/${path}');
    final Map<String, dynamic> $params = <String, dynamic>{
      'w': w,
      'h': h,
      'mode': mode,
      'blur': blur,
      'brightness': brightness,
      'format': format,
      'style': style,
      'channel': channel,
      'colorspace': colorspace,
      'overlay': overlay,
      'metadata': metadata,
      'quality': quality,
      'stylePlaceholders': stylePlaceholders,
      'cornerRadius': cornerRadius,
      'trim': trim,
      'wedgeWidthPercentage': wedgeWidthPercentage,
      'wedgeHeightPercentage': wedgeHeightPercentage,
    };
    final Map<String, String> $headers = {
      if (ifNoneMatch != null) 'If-None-Match': ifNoneMatch,
      if (cacheControl != null) 'Cache-Control': cacheControl,
    };
    final Request $request = Request(
      'GET',
      $url,
      client.baseUrl,
      parameters: $params,
      headers: $headers,
    );
    return client.send<List<String>, String>($request);
  }

  @override
  Future<Response<List<String>>> _resourceLocationDelete({
    required String? resourceLocation,
    String? cacheControl,
  }) {
    final Uri $url = Uri.parse('/${resourceLocation}');
    final Map<String, String> $headers = {
      if (cacheControl != null) 'Cache-Control': cacheControl,
    };
    final Request $request = Request(
      'DELETE',
      $url,
      client.baseUrl,
      headers: $headers,
    );
    return client.send<List<String>, String>($request);
  }
}
