import 'package:json_annotation/json_annotation.dart';
import 'package:collection/collection.dart';

enum ReplayEventResolution {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('SD')
  sd('SD'),
  @JsonValue('HD')
  hd('HD'),
  @JsonValue('4K')
  value_4k('4K'),
  @JsonValue('5K')
  value_5k('5K'),
  @JsonValue('8K')
  value_8k('8K');

  final String? value;

  const ReplayEventResolution(this.value);
}

enum ReplayEventV2Resolution {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('SD')
  sd('SD'),
  @JsonValue('HD')
  hd('HD'),
  @JsonValue('4K')
  value_4k('4K'),
  @JsonValue('5K')
  value_5k('5K'),
  @JsonValue('8K')
  value_8k('8K');

  final String? value;

  const ReplayEventV2Resolution(this.value);
}

enum LanguagePurpose {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue(1)
  value_1(1),
  @JsonValue(2)
  value_2(2),
  @JsonValue(3)
  value_3(3),
  @JsonValue(4)
  value_4(4);

  final int? value;

  const LanguagePurpose(this.value);
}

enum ErrorCode {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('NotFound')
  notfound('NotFound'),
  @JsonValue('InternalServerError')
  internalservererror('InternalServerError');

  final String? value;

  const ErrorCode(this.value);
}

enum ChannelV1ReplaySources {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('vod')
  vod('vod'),
  @JsonValue('app')
  app('app'),
  @JsonValue('cloud')
  cloud('cloud');

  final String? value;

  const ChannelV1ReplaySources(this.value);
}

enum ChannelReplaySources {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('vod')
  vod('vod'),
  @JsonValue('app')
  app('app'),
  @JsonValue('cloud')
  cloud('cloud');

  final String? value;

  const ChannelReplaySources(this.value);
}

enum ReplayProductReplayMode {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('EXACT')
  exact('EXACT'),
  @JsonValue('VOSDAL')
  vosdal('VOSDAL');

  final String? value;

  const ReplayProductReplayMode(this.value);
}
