// ignore_for_file: type=lint

import 'package:json_annotation/json_annotation.dart';
import 'package:collection/collection.dart';
import 'dart:convert';

import 'package:chopper/chopper.dart';

import 'client_mapping.dart';
import 'dart:async';
import 'package:chopper/chopper.dart' as chopper;
import 'personal_home_service.enums.swagger.dart' as enums;
export 'personal_home_service.enums.swagger.dart';

part 'personal_home_service.swagger.chopper.dart';
part 'personal_home_service.swagger.g.dart';

// **************************************************************************
// SwaggerChopperGenerator
// **************************************************************************

@ChopperApi()
abstract class PersonalHomeService extends ChopperService {
  static PersonalHomeService create({
    ChopperClient? client,
    Authenticator? authenticator,
    Uri? baseUrl,
    Iterable<dynamic>? interceptors,
  }) {
    if (client != null) {
      return _$PersonalHomeService(client);
    }

    final newClient = ChopperClient(
        services: [_$PersonalHomeService()],
        converter: $JsonSerializableConverter(),
        interceptors: interceptors ?? [],
        authenticator: authenticator,
        baseUrl: baseUrl ?? Uri.parse('http://'));
    return _$PersonalHomeService(newClient);
  }

  ///
  ///@param customerId CustomerId with country code (eg: 'C001869_pl')
  ///@param profileId
  ///@param language
  ///@param cpeId
  ///@param clientType Available values: STB-EOS, HZNGO, HZNGO-WEB, STB-SELENE, STB-APOLLO
  ///@param maxRes Available values : SD, HD, 4K, 5K, 8K
  ///@param cityId
  ///@param replayOptInDate
  ///@param goPlayable
  ///@param recentlyUsedApps Comma seperated list of OTT appid's to be returned to the client. Ex.: com.libertyglobal.app.amazon,com.libertyglobal.app.netflix
  ///@param sharedProfile Flag to determine call mode to RENG / DS service - when true or absent: subscriber mode is used, when false: user mode is used
  ///@param id Comma seperated list of collection id's to be returned to the client. Ex.: rented-with-continue-watching-id,rented-id
  ///@param appid Comma seperated list of OTT appid's to be returned to the client. Ex.: com.libertyglobal.app.primevideo,com.libertyglobal.app.netflix
  ///@param optIn
  ///@param version
  ///@param featureFlags Comma seperated list of feature flags. Currently client_mobile is supported
  ///@param filterOnDemand Filter TVOD/SVOD content
  ///@param includeExternalProvider Comma seperated list of branding provider Ids. Ex.: provider-AMAZON, provider-BBC,provider-STV,provider-MY5, provider-DISNEYPLUS
  ///@param productClass An identifier for the client device, making the request. For HZNGO Clients: Orion-DASH, Orion-HLS | For CPE Clients: EOSSTB, EOS2STB, HZNSTB, APLSTB
  ///@param replicationToken replication token used for recordings
  ///@param useSeriesLogic flag to enable series recommendations instead of episode recommendations
  ///@param amazonBookmarks Amazon specific external bookmarks list for continue watching
  ///@param amazonRecommendations Personalised list of recommendations from Amazon
  ///@param x-dev
  ///@param x-entitlements-token
  ///@param X-PHS-Explicit-Logging ONLY for debugging.  If set to true, then logs from below INFO will appear on INFO level for PHS components.
  Future<chopper.Response<Screen>>
      customersCustomerIdProfilesProfileIdScreenGet({
    required String? customerId,
    required String? profileId,
    String? language,
    String? cpeId,
    String? clientType,
    String? maxRes,
    int? cityId,
    String? replayOptInDate,
    bool? goPlayable,
    String? recentlyUsedApps,
    bool? sharedProfile,
    String? id,
    String? appid,
    bool? optIn,
    String? version,
    String? featureFlags,
    enums.CustomersCustomerIdProfilesProfileIdScreenGetFilterOnDemand?
        filterOnDemand,
    String? includeExternalProvider,
    String? productClass,
    String? replicationToken,
    bool? useSeriesLogic,
    String? amazonBookmarks,
    String? amazonRecommendations,
    String? xDev,
    String? xEntitlementsToken = 'X-Entitlements-Token',
    String? xPHSExplicitLogging,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Screen, () => Screen.fromJsonFactory);

    return _customersCustomerIdProfilesProfileIdScreenGet(
        customerId: customerId,
        profileId: profileId,
        language: language,
        cpeId: cpeId,
        clientType: clientType,
        maxRes: maxRes,
        cityId: cityId,
        replayOptInDate: replayOptInDate,
        goPlayable: goPlayable,
        recentlyUsedApps: recentlyUsedApps,
        sharedProfile: sharedProfile,
        id: id,
        appid: appid,
        optIn: optIn,
        version: version,
        featureFlags: featureFlags,
        filterOnDemand: filterOnDemand?.value?.toString(),
        includeExternalProvider: includeExternalProvider,
        productClass: productClass,
        replicationToken: replicationToken,
        useSeriesLogic: useSeriesLogic,
        amazonBookmarks: amazonBookmarks,
        amazonRecommendations: amazonRecommendations,
        xDev: xDev,
        xEntitlementsToken: xEntitlementsToken,
        xPHSExplicitLogging: xPHSExplicitLogging,
        cacheControl: cacheControl);
  }

  ///
  ///@param customerId CustomerId with country code (eg: 'C001869_pl')
  ///@param profileId
  ///@param language
  ///@param cpeId
  ///@param clientType Available values: STB-EOS, HZNGO, HZNGO-WEB, STB-SELENE, STB-APOLLO
  ///@param maxRes Available values : SD, HD, 4K, 5K, 8K
  ///@param cityId
  ///@param replayOptInDate
  ///@param goPlayable
  ///@param recentlyUsedApps Comma seperated list of OTT appid's to be returned to the client. Ex.: com.libertyglobal.app.amazon,com.libertyglobal.app.netflix
  ///@param sharedProfile Flag to determine call mode to RENG / DS service - when true or absent: subscriber mode is used, when false: user mode is used
  ///@param id Comma seperated list of collection id's to be returned to the client. Ex.: rented-with-continue-watching-id,rented-id
  ///@param appid Comma seperated list of OTT appid's to be returned to the client. Ex.: com.libertyglobal.app.primevideo,com.libertyglobal.app.netflix
  ///@param optIn
  ///@param version
  ///@param featureFlags Comma seperated list of feature flags. Currently client_mobile is supported
  ///@param filterOnDemand Filter TVOD/SVOD content
  ///@param includeExternalProvider Comma seperated list of branding provider Ids. Ex.: provider-AMAZON, provider-BBC,provider-STV,provider-MY5, provider-DISNEYPLUS
  ///@param productClass An identifier for the client device, making the request. For HZNGO Clients: Orion-DASH, Orion-HLS | For CPE Clients: EOSSTB, EOS2STB, HZNSTB, APLSTB
  ///@param replicationToken replication token used for recordings
  ///@param useSeriesLogic flag to enable series recommendations instead of episode recommendations
  ///@param amazonBookmarks Amazon specific external bookmarks list for continue watching
  ///@param amazonRecommendations Personalised list of recommendations from Amazon
  ///@param x-dev
  ///@param x-entitlements-token
  ///@param X-PHS-Explicit-Logging ONLY for debugging.  If set to true, then logs from below INFO will appear on INFO level for PHS components.
  @Get(path: '/customers/{customerId}/profiles/{profileId}/screen')
  Future<chopper.Response<Screen>>
      _customersCustomerIdProfilesProfileIdScreenGet({
    @Path('customerId')
        required String? customerId,
    @Path('profileId')
        required String? profileId,
    @Query('language')
        String? language,
    @Query('cpeId')
        String? cpeId,
    @Query('clientType')
        String? clientType,
    @Query('maxRes')
        String? maxRes,
    @Query('cityId')
        int? cityId,
    @Query('replayOptInDate')
        String? replayOptInDate,
    @Query('goPlayable')
        bool? goPlayable,
    @Query('recentlyUsedApps')
        String? recentlyUsedApps,
    @Query('sharedProfile')
        bool? sharedProfile,
    @Query('id')
        String? id,
    @Query('appid')
        String? appid,
    @Query('optIn')
        bool? optIn,
    @Query('version')
        String? version,
    @Query('featureFlags')
        String? featureFlags,
    @Query('filterOnDemand')
        String? filterOnDemand,
    @Query('includeExternalProvider')
        String? includeExternalProvider,
    @Query('productClass')
        String? productClass,
    @Query('replicationToken')
        String? replicationToken,
    @Query('useSeriesLogic')
        bool? useSeriesLogic,
    @Query('amazonBookmarks')
        String? amazonBookmarks,
    @Query('amazonRecommendations')
        String? amazonRecommendations,
    @Header('x-dev')
        String? xDev,
    @Header('x-entitlements-token')
        String? xEntitlementsToken = 'X-Entitlements-Token',
    @Header('X-PHS-Explicit-Logging')
        String? xPHSExplicitLogging,
    @Header('Cache-Control')
        String? cacheControl,
  });

  ///
  ///@param customerId CustomerId with country code (eg: 'C001869_pl')
  ///@param profileId
  ///@param language
  ///@param cpeId
  ///@param clientType Available values: STB-EOS, HZNGO, HZNGO-WEB, STB-SELENE, STB-APOLLO
  ///@param maxRes Available values : SD, HD, 4K, 5K, 8K
  ///@param cityId
  ///@param replayOptInDate
  ///@param goPlayable
  ///@param nrOfCandidates
  ///@param sharedProfile Flag to determine call mode to RENG / DS service - when true or absent: subscriber mode is used, when false: user mode is used
  ///@param optIn
  ///@param version
  ///@param featureFlags Comma seperated list of feature flags. Currently client_mobile is supported
  ///@param filterOnDemand Filter TVOD/SVOD content
  ///@param includeExternalProvider Comma seperated list of branding provider Ids. Ex.: provider-AMAZON, provider-BBC,provider-STV,provider-MY5, provider-DISNEYPLUS
  ///@param useSeriesLogic flag to enable series recommendations instead of episode recommendations
  ///@param x-dev
  ///@param x-entitlements-token
  ///@param X-PHS-Explicit-Logging ONLY for debugging.  If set to true, then logs from below INFO will appear on INFO level for PHS components.
  Future<chopper.Response<Aspot>> customersCustomerIdProfilesProfileIdASpotGet({
    required String? customerId,
    required String? profileId,
    String? language,
    String? cpeId,
    String? clientType,
    String? maxRes,
    int? cityId,
    String? replayOptInDate,
    bool? goPlayable,
    int? nrOfCandidates,
    bool? sharedProfile,
    bool? optIn,
    String? version,
    String? featureFlags,
    enums.CustomersCustomerIdProfilesProfileIdASpotGetFilterOnDemand?
        filterOnDemand,
    String? includeExternalProvider,
    bool? useSeriesLogic,
    String? xDev,
    String? xEntitlementsToken = 'X-Entitlements-Token',
    String? xPHSExplicitLogging,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Aspot, () => Aspot.fromJsonFactory);

    return _customersCustomerIdProfilesProfileIdASpotGet(
        customerId: customerId,
        profileId: profileId,
        language: language,
        cpeId: cpeId,
        clientType: clientType,
        maxRes: maxRes,
        cityId: cityId,
        replayOptInDate: replayOptInDate,
        goPlayable: goPlayable,
        nrOfCandidates: nrOfCandidates,
        sharedProfile: sharedProfile,
        optIn: optIn,
        version: version,
        featureFlags: featureFlags,
        filterOnDemand: filterOnDemand?.value?.toString(),
        includeExternalProvider: includeExternalProvider,
        useSeriesLogic: useSeriesLogic,
        xDev: xDev,
        xEntitlementsToken: xEntitlementsToken,
        xPHSExplicitLogging: xPHSExplicitLogging,
        cacheControl: cacheControl);
  }

  ///
  ///@param customerId CustomerId with country code (eg: 'C001869_pl')
  ///@param profileId
  ///@param language
  ///@param cpeId
  ///@param clientType Available values: STB-EOS, HZNGO, HZNGO-WEB, STB-SELENE, STB-APOLLO
  ///@param maxRes Available values : SD, HD, 4K, 5K, 8K
  ///@param cityId
  ///@param replayOptInDate
  ///@param goPlayable
  ///@param nrOfCandidates
  ///@param sharedProfile Flag to determine call mode to RENG / DS service - when true or absent: subscriber mode is used, when false: user mode is used
  ///@param optIn
  ///@param version
  ///@param featureFlags Comma seperated list of feature flags. Currently client_mobile is supported
  ///@param filterOnDemand Filter TVOD/SVOD content
  ///@param includeExternalProvider Comma seperated list of branding provider Ids. Ex.: provider-AMAZON, provider-BBC,provider-STV,provider-MY5, provider-DISNEYPLUS
  ///@param useSeriesLogic flag to enable series recommendations instead of episode recommendations
  ///@param x-dev
  ///@param x-entitlements-token
  ///@param X-PHS-Explicit-Logging ONLY for debugging.  If set to true, then logs from below INFO will appear on INFO level for PHS components.
  @Get(path: '/customers/{customerId}/profiles/{profileId}/a-spot')
  Future<chopper.Response<Aspot>>
      _customersCustomerIdProfilesProfileIdASpotGet({
    @Path('customerId')
        required String? customerId,
    @Path('profileId')
        required String? profileId,
    @Query('language')
        String? language,
    @Query('cpeId')
        String? cpeId,
    @Query('clientType')
        String? clientType,
    @Query('maxRes')
        String? maxRes,
    @Query('cityId')
        int? cityId,
    @Query('replayOptInDate')
        String? replayOptInDate,
    @Query('goPlayable')
        bool? goPlayable,
    @Query('nrOfCandidates')
        int? nrOfCandidates,
    @Query('sharedProfile')
        bool? sharedProfile,
    @Query('optIn')
        bool? optIn,
    @Query('version')
        String? version,
    @Query('featureFlags')
        String? featureFlags,
    @Query('filterOnDemand')
        String? filterOnDemand,
    @Query('includeExternalProvider')
        String? includeExternalProvider,
    @Query('useSeriesLogic')
        bool? useSeriesLogic,
    @Header('x-dev')
        String? xDev,
    @Header('x-entitlements-token')
        String? xEntitlementsToken = 'X-Entitlements-Token',
    @Header('X-PHS-Explicit-Logging')
        String? xPHSExplicitLogging,
    @Header('Cache-Control')
        String? cacheControl,
  });

  ///
  ///@param customerId CustomerId with country code (eg: 'C001869_pl')
  ///@param profileId
  ///@param language
  ///@param cpeId
  ///@param clientType Available values: STB-EOS, HZNGO, HZNGO-WEB, STB-SELENE, STB-APOLLO
  ///@param maxRes Available values : SD, HD, 4K, 5K, 8K
  ///@param cityId
  ///@param replayOptInDate
  ///@param goPlayable
  ///@param limit Max amount of aspot items to be returned
  ///@param sharedProfile Flag to determine call mode to RENG / DS service - when true or absent: subscriber mode is used, when false: user mode is used
  ///@param optIn
  ///@param version
  ///@param featureFlags Comma seperated list of feature flags. Currently client_mobile is supported
  ///@param filterOnDemand Filter TVOD/SVOD content
  ///@param includeExternalProvider Comma seperated list of branding provider Ids. Ex.: provider-AMAZON, provider-BBC,provider-STV,provider-MY5, provider-DISNEYPLUS
  ///@param useSeriesLogic flag to enable series recommendations instead of episode recommendations
  ///@param x-dev
  ///@param x-entitlements-token
  ///@param X-PHS-Explicit-Logging ONLY for debugging.  If set to true, then logs from below INFO will appear on INFO level for PHS components.
  Future<chopper.Response<List<Aspot>>>
      customersCustomerIdProfilesProfileIdASpotsGet({
    required String? customerId,
    required String? profileId,
    String? language,
    String? cpeId,
    String? clientType,
    String? maxRes,
    int? cityId,
    String? replayOptInDate,
    bool? goPlayable,
    int? limit,
    bool? sharedProfile,
    bool? optIn,
    String? version,
    String? featureFlags,
    enums.CustomersCustomerIdProfilesProfileIdASpotsGetFilterOnDemand?
        filterOnDemand,
    String? includeExternalProvider,
    bool? useSeriesLogic,
    String? xDev,
    String? xEntitlementsToken = 'X-Entitlements-Token',
    String? xPHSExplicitLogging,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(Aspot, () => Aspot.fromJsonFactory);

    return _customersCustomerIdProfilesProfileIdASpotsGet(
        customerId: customerId,
        profileId: profileId,
        language: language,
        cpeId: cpeId,
        clientType: clientType,
        maxRes: maxRes,
        cityId: cityId,
        replayOptInDate: replayOptInDate,
        goPlayable: goPlayable,
        limit: limit,
        sharedProfile: sharedProfile,
        optIn: optIn,
        version: version,
        featureFlags: featureFlags,
        filterOnDemand: filterOnDemand?.value?.toString(),
        includeExternalProvider: includeExternalProvider,
        useSeriesLogic: useSeriesLogic,
        xDev: xDev,
        xEntitlementsToken: xEntitlementsToken,
        xPHSExplicitLogging: xPHSExplicitLogging,
        cacheControl: cacheControl);
  }

  ///
  ///@param customerId CustomerId with country code (eg: 'C001869_pl')
  ///@param profileId
  ///@param language
  ///@param cpeId
  ///@param clientType Available values: STB-EOS, HZNGO, HZNGO-WEB, STB-SELENE, STB-APOLLO
  ///@param maxRes Available values : SD, HD, 4K, 5K, 8K
  ///@param cityId
  ///@param replayOptInDate
  ///@param goPlayable
  ///@param limit Max amount of aspot items to be returned
  ///@param sharedProfile Flag to determine call mode to RENG / DS service - when true or absent: subscriber mode is used, when false: user mode is used
  ///@param optIn
  ///@param version
  ///@param featureFlags Comma seperated list of feature flags. Currently client_mobile is supported
  ///@param filterOnDemand Filter TVOD/SVOD content
  ///@param includeExternalProvider Comma seperated list of branding provider Ids. Ex.: provider-AMAZON, provider-BBC,provider-STV,provider-MY5, provider-DISNEYPLUS
  ///@param useSeriesLogic flag to enable series recommendations instead of episode recommendations
  ///@param x-dev
  ///@param x-entitlements-token
  ///@param X-PHS-Explicit-Logging ONLY for debugging.  If set to true, then logs from below INFO will appear on INFO level for PHS components.
  @Get(path: '/customers/{customerId}/profiles/{profileId}/a-spots')
  Future<chopper.Response<List<Aspot>>>
      _customersCustomerIdProfilesProfileIdASpotsGet({
    @Path('customerId')
        required String? customerId,
    @Path('profileId')
        required String? profileId,
    @Query('language')
        String? language,
    @Query('cpeId')
        String? cpeId,
    @Query('clientType')
        String? clientType,
    @Query('maxRes')
        String? maxRes,
    @Query('cityId')
        int? cityId,
    @Query('replayOptInDate')
        String? replayOptInDate,
    @Query('goPlayable')
        bool? goPlayable,
    @Query('limit')
        int? limit,
    @Query('sharedProfile')
        bool? sharedProfile,
    @Query('optIn')
        bool? optIn,
    @Query('version')
        String? version,
    @Query('featureFlags')
        String? featureFlags,
    @Query('filterOnDemand')
        String? filterOnDemand,
    @Query('includeExternalProvider')
        String? includeExternalProvider,
    @Query('useSeriesLogic')
        bool? useSeriesLogic,
    @Header('x-dev')
        String? xDev,
    @Header('x-entitlements-token')
        String? xEntitlementsToken = 'X-Entitlements-Token',
    @Header('X-PHS-Explicit-Logging')
        String? xPHSExplicitLogging,
    @Header('Cache-Control')
        String? cacheControl,
  });

  ///
  ///@param customerId CustomerId with country code (eg: 'C001869_pl')
  ///@param profileId
  ///@param language
  ///@param clientType Available values: STB-EOS, HZNGO, HZNGO-WEB, STB-SELENE, STB-APOLLO
  ///@param optIn
  ///@param version
  ///@param featureFlags Comma seperated list of feature flags. Currently client_mobile is supported
  ///@param x-entitlements-token
  Future<chopper.Response<Structure>>
      customersCustomerIdProfilesProfileIdStructureGet({
    required String? customerId,
    required String? profileId,
    String? language,
    String? clientType,
    bool? optIn,
    String? version,
    String? featureFlags,
    String? xEntitlementsToken = 'X-Entitlements-Token',
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        StructureItem, () => StructureItem.fromJsonFactory);

    return _customersCustomerIdProfilesProfileIdStructureGet(
        customerId: customerId,
        profileId: profileId,
        language: language,
        clientType: clientType,
        optIn: optIn,
        version: version,
        featureFlags: featureFlags,
        xEntitlementsToken: xEntitlementsToken,
        cacheControl: cacheControl);
  }

  ///
  ///@param customerId CustomerId with country code (eg: 'C001869_pl')
  ///@param profileId
  ///@param language
  ///@param clientType Available values: STB-EOS, HZNGO, HZNGO-WEB, STB-SELENE, STB-APOLLO
  ///@param optIn
  ///@param version
  ///@param featureFlags Comma seperated list of feature flags. Currently client_mobile is supported
  ///@param x-entitlements-token
  @Get(path: '/customers/{customerId}/profiles/{profileId}/structure')
  Future<chopper.Response<Structure>>
      _customersCustomerIdProfilesProfileIdStructureGet({
    @Path('customerId')
        required String? customerId,
    @Path('profileId')
        required String? profileId,
    @Query('language')
        String? language,
    @Query('clientType')
        String? clientType,
    @Query('optIn')
        bool? optIn,
    @Query('version')
        String? version,
    @Query('featureFlags')
        String? featureFlags,
    @Header('x-entitlements-token')
        String? xEntitlementsToken = 'X-Entitlements-Token',
    @Header('Cache-Control')
        String? cacheControl,
  });

  ///
  ///@param profileId
  ///@param language
  ///@param clientType Available values: STB-EOS, HZNGO, HZNGO-WEB, STB-SELENE, STB-APOLLO
  ///@param optIn
  ///@param version
  ///@param featureFlags Comma seperated list of feature flags. Currently client_mobile is supported
  ///@param x-entitlements-token
  Future<chopper.Response<Structure>> structureGet({
    String? profileId,
    String? language,
    String? clientType,
    bool? optIn,
    String? version,
    String? featureFlags,
    String? xEntitlementsToken = 'X-Entitlements-Token',
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(
        StructureItem, () => StructureItem.fromJsonFactory);

    return _structureGet(
        profileId: profileId,
        language: language,
        clientType: clientType,
        optIn: optIn,
        version: version,
        featureFlags: featureFlags,
        xEntitlementsToken: xEntitlementsToken,
        cacheControl: cacheControl);
  }

  ///
  ///@param profileId
  ///@param language
  ///@param clientType Available values: STB-EOS, HZNGO, HZNGO-WEB, STB-SELENE, STB-APOLLO
  ///@param optIn
  ///@param version
  ///@param featureFlags Comma seperated list of feature flags. Currently client_mobile is supported
  ///@param x-entitlements-token
  @Get(path: '/structure')
  Future<chopper.Response<Structure>> _structureGet({
    @Query('profileId')
        String? profileId,
    @Query('language')
        String? language,
    @Query('clientType')
        String? clientType,
    @Query('optIn')
        bool? optIn,
    @Query('version')
        String? version,
    @Query('featureFlags')
        String? featureFlags,
    @Header('x-entitlements-token')
        String? xEntitlementsToken = 'X-Entitlements-Token',
    @Header('Cache-Control')
        String? cacheControl,
  });

  ///
  ///@param profileId
  ///@param language
  ///@param clientType Available values: STB-EOS, HZNGO, HZNGO-WEB, STB-SELENE, STB-APOLLO
  ///@param maxRes Available values : SD, HD, 4K, 5K, 8K
  ///@param cityId
  ///@param productClass An identifier for the client device, making the request. For HZNGO Clients: Orion-DASH, Orion-HLS | For CPE Clients: EOSSTB, EOS2STB, HZNSTB, APLSTB
  ///@param version
  ///@param featureFlags Comma seperated list of feature flags. Currently client_mobile is supported
  ///@param x-entitlements-token
  ///@param X-PHS-Explicit-Logging ONLY for debugging.  If set to true, then logs from below INFO will appear on INFO level for PHS components.
  ///@param User-Agent Custom HTTP header containing the customers userAgent.
  ///@param includeExternalProvider Comma seperated list of branding provider Ids. Ex.: provider-AMAZON, provider-BBC,provider-STV,provider-MY5, provider-DISNEYPLUS
  Future<chopper.Response<TopShelf>> topshelfGet({
    String? profileId,
    String? language,
    String? clientType,
    String? maxRes,
    required int? cityId,
    required String? productClass,
    String? version,
    String? featureFlags,
    String? xEntitlementsToken = 'X-Entitlements-Token',
    String? xPHSExplicitLogging,
    String? userAgent,
    String? includeExternalProvider,
    String? cacheControl,
  }) {
    generatedMapping.putIfAbsent(TopShelf, () => TopShelf.fromJsonFactory);

    return _topshelfGet(
        profileId: profileId,
        language: language,
        clientType: clientType,
        maxRes: maxRes,
        cityId: cityId,
        productClass: productClass,
        version: version,
        featureFlags: featureFlags,
        xEntitlementsToken: xEntitlementsToken,
        xPHSExplicitLogging: xPHSExplicitLogging,
        userAgent: userAgent,
        includeExternalProvider: includeExternalProvider,
        cacheControl: cacheControl);
  }

  ///
  ///@param profileId
  ///@param language
  ///@param clientType Available values: STB-EOS, HZNGO, HZNGO-WEB, STB-SELENE, STB-APOLLO
  ///@param maxRes Available values : SD, HD, 4K, 5K, 8K
  ///@param cityId
  ///@param productClass An identifier for the client device, making the request. For HZNGO Clients: Orion-DASH, Orion-HLS | For CPE Clients: EOSSTB, EOS2STB, HZNSTB, APLSTB
  ///@param version
  ///@param featureFlags Comma seperated list of feature flags. Currently client_mobile is supported
  ///@param x-entitlements-token
  ///@param X-PHS-Explicit-Logging ONLY for debugging.  If set to true, then logs from below INFO will appear on INFO level for PHS components.
  ///@param User-Agent Custom HTTP header containing the customers userAgent.
  ///@param includeExternalProvider Comma seperated list of branding provider Ids. Ex.: provider-AMAZON, provider-BBC,provider-STV,provider-MY5, provider-DISNEYPLUS
  @Get(path: '/topshelf')
  Future<chopper.Response<TopShelf>> _topshelfGet({
    @Query('profileId')
        String? profileId,
    @Query('language')
        String? language,
    @Query('clientType')
        String? clientType,
    @Query('maxRes')
        String? maxRes,
    @Query('cityId')
        required int? cityId,
    @Query('productClass')
        required String? productClass,
    @Query('version')
        String? version,
    @Query('featureFlags')
        String? featureFlags,
    @Header('x-entitlements-token')
        String? xEntitlementsToken = 'X-Entitlements-Token',
    @Header('X-PHS-Explicit-Logging')
        String? xPHSExplicitLogging,
    @Header('User-Agent')
        String? userAgent,
    @Query('includeExternalProvider')
        String? includeExternalProvider,
    @Header('Cache-Control')
        String? cacheControl,
  });
}

@JsonSerializable(explicitToJson: true)
class CustomerAccessError {
  CustomerAccessError({
    this.errorMessage,
  });

  factory CustomerAccessError.fromJson(Map<String, dynamic> json) =>
      _$CustomerAccessErrorFromJson(json);

  static const toJsonFactory = _$CustomerAccessErrorToJson;
  Map<String, dynamic> toJson() => _$CustomerAccessErrorToJson(this);

  @JsonKey(name: 'errorMessage', includeIfNull: false, defaultValue: '')
  final String? errorMessage;
  static const fromJsonFactory = _$CustomerAccessErrorFromJson;

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CustomerAccessError &&
            (identical(other.errorMessage, errorMessage) ||
                const DeepCollectionEquality()
                    .equals(other.errorMessage, errorMessage)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(errorMessage) ^ runtimeType.hashCode;
}

extension $CustomerAccessErrorExtension on CustomerAccessError {
  CustomerAccessError copyWith({String? errorMessage}) {
    return CustomerAccessError(errorMessage: errorMessage ?? this.errorMessage);
  }

  CustomerAccessError copyWithWrapped({Wrapped<String?>? errorMessage}) {
    return CustomerAccessError(
        errorMessage:
            (errorMessage != null ? errorMessage.value : this.errorMessage));
  }
}

@JsonSerializable(explicitToJson: true)
class Screen {
  Screen({
    required this.collections,
    this.aspot,
  });

  factory Screen.fromJson(Map<String, dynamic> json) => _$ScreenFromJson(json);

  static const toJsonFactory = _$ScreenToJson;
  Map<String, dynamic> toJson() => _$ScreenToJson(this);

  @JsonKey(
      name: 'collections',
      includeIfNull: false,
      defaultValue: <ScreenCollection>[])
  final List<ScreenCollection> collections;
  @JsonKey(name: 'aspot', includeIfNull: false)
  final Aspot? aspot;
  static const fromJsonFactory = _$ScreenFromJson;

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Screen &&
            (identical(other.collections, collections) ||
                const DeepCollectionEquality()
                    .equals(other.collections, collections)) &&
            (identical(other.aspot, aspot) ||
                const DeepCollectionEquality().equals(other.aspot, aspot)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(collections) ^
      const DeepCollectionEquality().hash(aspot) ^
      runtimeType.hashCode;
}

extension $ScreenExtension on Screen {
  Screen copyWith({List<ScreenCollection>? collections, Aspot? aspot}) {
    return Screen(
        collections: collections ?? this.collections,
        aspot: aspot ?? this.aspot);
  }

  Screen copyWithWrapped(
      {Wrapped<List<ScreenCollection>>? collections, Wrapped<Aspot?>? aspot}) {
    return Screen(
        collections:
            (collections != null ? collections.value : this.collections),
        aspot: (aspot != null ? aspot.value : this.aspot));
  }
}

@JsonSerializable(explicitToJson: true)
class ScreenCollection {
  ScreenCollection({
    required this.id,
    this.title,
    required this.type,
    this.layout,
    this.items,
    this.subcollections,
  });

  factory ScreenCollection.fromJson(Map<String, dynamic> json) =>
      _$ScreenCollectionFromJson(json);

  static const toJsonFactory = _$ScreenCollectionToJson;
  Map<String, dynamic> toJson() => _$ScreenCollectionToJson(this);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String id;
  @JsonKey(name: 'title', includeIfNull: false, defaultValue: '')
  final String? title;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String type;
  @JsonKey(
    name: 'layout',
    includeIfNull: false,
    toJson: screenCollectionLayoutToJson,
    fromJson: screenCollectionLayoutFromJson,
  )
  final enums.ScreenCollectionLayout? layout;
  @JsonKey(name: 'items', includeIfNull: false, defaultValue: <ScreenItem>[])
  final List<ScreenItem>? items;
  @JsonKey(
      name: 'subcollections',
      includeIfNull: false,
      defaultValue: <ScreenSubcollection>[])
  final List<ScreenSubcollection>? subcollections;
  static const fromJsonFactory = _$ScreenCollectionFromJson;

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ScreenCollection &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.title, title) ||
                const DeepCollectionEquality().equals(other.title, title)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)) &&
            (identical(other.layout, layout) ||
                const DeepCollectionEquality().equals(other.layout, layout)) &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.subcollections, subcollections) ||
                const DeepCollectionEquality()
                    .equals(other.subcollections, subcollections)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(title) ^
      const DeepCollectionEquality().hash(type) ^
      const DeepCollectionEquality().hash(layout) ^
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(subcollections) ^
      runtimeType.hashCode;
}

extension $ScreenCollectionExtension on ScreenCollection {
  ScreenCollection copyWith(
      {String? id,
      String? title,
      String? type,
      enums.ScreenCollectionLayout? layout,
      List<ScreenItem>? items,
      List<ScreenSubcollection>? subcollections}) {
    return ScreenCollection(
        id: id ?? this.id,
        title: title ?? this.title,
        type: type ?? this.type,
        layout: layout ?? this.layout,
        items: items ?? this.items,
        subcollections: subcollections ?? this.subcollections);
  }

  ScreenCollection copyWithWrapped(
      {Wrapped<String>? id,
      Wrapped<String?>? title,
      Wrapped<String>? type,
      Wrapped<enums.ScreenCollectionLayout?>? layout,
      Wrapped<List<ScreenItem>?>? items,
      Wrapped<List<ScreenSubcollection>?>? subcollections}) {
    return ScreenCollection(
        id: (id != null ? id.value : this.id),
        title: (title != null ? title.value : this.title),
        type: (type != null ? type.value : this.type),
        layout: (layout != null ? layout.value : this.layout),
        items: (items != null ? items.value : this.items),
        subcollections: (subcollections != null
            ? subcollections.value
            : this.subcollections));
  }
}

@JsonSerializable(explicitToJson: true)
class ScreenSubcollection {
  ScreenSubcollection({
    required this.id,
    required this.title,
    required this.type,
    this.lastInteracted,
    this.items,
  });

  factory ScreenSubcollection.fromJson(Map<String, dynamic> json) =>
      _$ScreenSubcollectionFromJson(json);

  static const toJsonFactory = _$ScreenSubcollectionToJson;
  Map<String, dynamic> toJson() => _$ScreenSubcollectionToJson(this);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String id;
  @JsonKey(name: 'title', includeIfNull: false, defaultValue: '')
  final String title;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String type;
  @JsonKey(name: 'lastInteracted', includeIfNull: false)
  final DateTime? lastInteracted;
  @JsonKey(name: 'items', includeIfNull: false, defaultValue: <ScreenItem>[])
  final List<ScreenItem>? items;
  static const fromJsonFactory = _$ScreenSubcollectionFromJson;

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ScreenSubcollection &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.title, title) ||
                const DeepCollectionEquality().equals(other.title, title)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)) &&
            (identical(other.lastInteracted, lastInteracted) ||
                const DeepCollectionEquality()
                    .equals(other.lastInteracted, lastInteracted)) &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(title) ^
      const DeepCollectionEquality().hash(type) ^
      const DeepCollectionEquality().hash(lastInteracted) ^
      const DeepCollectionEquality().hash(items) ^
      runtimeType.hashCode;
}

extension $ScreenSubcollectionExtension on ScreenSubcollection {
  ScreenSubcollection copyWith(
      {String? id,
      String? title,
      String? type,
      DateTime? lastInteracted,
      List<ScreenItem>? items}) {
    return ScreenSubcollection(
        id: id ?? this.id,
        title: title ?? this.title,
        type: type ?? this.type,
        lastInteracted: lastInteracted ?? this.lastInteracted,
        items: items ?? this.items);
  }

  ScreenSubcollection copyWithWrapped(
      {Wrapped<String>? id,
      Wrapped<String>? title,
      Wrapped<String>? type,
      Wrapped<DateTime?>? lastInteracted,
      Wrapped<List<ScreenItem>?>? items}) {
    return ScreenSubcollection(
        id: (id != null ? id.value : this.id),
        title: (title != null ? title.value : this.title),
        type: (type != null ? type.value : this.type),
        lastInteracted: (lastInteracted != null
            ? lastInteracted.value
            : this.lastInteracted),
        items: (items != null ? items.value : this.items));
  }
}

@JsonSerializable(explicitToJson: true)
class ScreenItem {
  ScreenItem({
    this.id,
    this.title,
    this.type,
    this.brandingProviderId,
    this.subType,
    this.ageRating,
    this.channelId,
    this.startTime,
    this.endTime,
    this.duration,
    this.bookmark,
    this.priceDisplay,
    this.minPriceDisplay,
    this.tvodEntitlementEnd,
    this.entitlementEnd,
    this.isRemoved,
    this.isExpired,
    this.isBoxset,
    this.seasonNumber,
    this.episodeNumber,
    this.recordingState,
    this.seasonCount,
    this.expirationDate,
    this.earliestBroadcastStartTime,
    this.isPurchased,
    this.seriesId,
    this.rootId,
    this.providerId,
    this.interacted,
    this.image,
    this.externalAppId,
    this.externalAppDeepLink,
    this.imageVersion,
    this.entitlementState,
    this.goPlayable,
    this.episodeName,
    this.url,
    this.mostRelevantEpisode,
    this.isSplitProgram,
    this.shortDescription,
    this.genres,
    this.fromRemoteBookmark,
  });

  factory ScreenItem.fromJson(Map<String, dynamic> json) =>
      _$ScreenItemFromJson(json);

  static const toJsonFactory = _$ScreenItemToJson;
  Map<String, dynamic> toJson() => _$ScreenItemToJson(this);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String? id;
  @JsonKey(name: 'title', includeIfNull: false, defaultValue: '')
  final String? title;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  @JsonKey(name: 'brandingProviderId', includeIfNull: false, defaultValue: '')
  final String? brandingProviderId;
  @JsonKey(
    name: 'subType',
    includeIfNull: false,
    toJson: screenItemSubTypeToJson,
    fromJson: screenItemSubTypeFromJson,
  )
  final enums.ScreenItemSubType? subType;
  @JsonKey(name: 'ageRating', includeIfNull: false, defaultValue: '')
  final String? ageRating;
  @JsonKey(name: 'channelId', includeIfNull: false, defaultValue: '')
  final String? channelId;
  @JsonKey(name: 'startTime', includeIfNull: false)
  final DateTime? startTime;
  @JsonKey(name: 'endTime', includeIfNull: false)
  final DateTime? endTime;
  @JsonKey(name: 'duration', includeIfNull: false)
  final int? duration;
  @JsonKey(name: 'bookmark', includeIfNull: false)
  final int? bookmark;
  @JsonKey(name: 'priceDisplay', includeIfNull: false, defaultValue: '')
  final String? priceDisplay;
  @JsonKey(name: 'minPriceDisplay', includeIfNull: false, defaultValue: '')
  final String? minPriceDisplay;
  @JsonKey(name: 'tvodEntitlementEnd', includeIfNull: false)
  final DateTime? tvodEntitlementEnd;
  @JsonKey(name: 'entitlementEnd', includeIfNull: false)
  final DateTime? entitlementEnd;
  @JsonKey(name: 'isRemoved', includeIfNull: false)
  final bool? isRemoved;
  @JsonKey(name: 'isExpired', includeIfNull: false)
  final bool? isExpired;
  @JsonKey(name: 'isBoxset', includeIfNull: false)
  final bool? isBoxset;
  @JsonKey(name: 'seasonNumber', includeIfNull: false)
  final int? seasonNumber;
  @JsonKey(name: 'episodeNumber', includeIfNull: false)
  final int? episodeNumber;
  @JsonKey(name: 'recordingState', includeIfNull: false, defaultValue: '')
  final String? recordingState;
  @JsonKey(name: 'seasonCount', includeIfNull: false)
  final int? seasonCount;
  @JsonKey(name: 'expirationDate', includeIfNull: false)
  final DateTime? expirationDate;
  @JsonKey(name: 'earliestBroadcastStartTime', includeIfNull: false)
  final DateTime? earliestBroadcastStartTime;
  @JsonKey(name: 'isPurchased', includeIfNull: false)
  final bool? isPurchased;
  @JsonKey(name: 'seriesId', includeIfNull: false, defaultValue: '')
  final String? seriesId;
  @JsonKey(name: 'rootId', includeIfNull: false, defaultValue: '')
  final String? rootId;
  @JsonKey(name: 'providerId', includeIfNull: false, defaultValue: '')
  final String? providerId;
  @JsonKey(name: 'interacted', includeIfNull: false)
  final bool? interacted;
  @JsonKey(name: 'image', includeIfNull: false, defaultValue: '')
  final String? image;
  @JsonKey(name: 'externalAppId', includeIfNull: false, defaultValue: '')
  final String? externalAppId;
  @JsonKey(name: 'externalAppDeepLink', includeIfNull: false, defaultValue: '')
  final String? externalAppDeepLink;
  @JsonKey(name: 'imageVersion', includeIfNull: false, defaultValue: '')
  final String? imageVersion;
  @JsonKey(
    name: 'entitlementState',
    includeIfNull: false,
    toJson: screenItemEntitlementStateToJson,
    fromJson: screenItemEntitlementStateFromJson,
  )
  final enums.ScreenItemEntitlementState? entitlementState;
  @JsonKey(name: 'goPlayable', includeIfNull: false)
  final bool? goPlayable;
  @JsonKey(name: 'episodeName', includeIfNull: false, defaultValue: '')
  final String? episodeName;
  @JsonKey(name: 'url', includeIfNull: false, defaultValue: '')
  final String? url;
  @JsonKey(name: 'mostRelevantEpisode', includeIfNull: false, defaultValue: '')
  final String? mostRelevantEpisode;
  @JsonKey(name: 'isSplitProgram', includeIfNull: false)
  final bool? isSplitProgram;
  @JsonKey(name: 'shortDescription', includeIfNull: false, defaultValue: '')
  final String? shortDescription;
  @JsonKey(name: 'genres', includeIfNull: false, defaultValue: <String>[])
  final List<String>? genres;
  @JsonKey(name: 'fromRemoteBookmark', includeIfNull: false)
  final bool? fromRemoteBookmark;
  static const fromJsonFactory = _$ScreenItemFromJson;

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ScreenItem &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.title, title) ||
                const DeepCollectionEquality().equals(other.title, title)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)) &&
            (identical(other.brandingProviderId, brandingProviderId) ||
                const DeepCollectionEquality()
                    .equals(other.brandingProviderId, brandingProviderId)) &&
            (identical(other.subType, subType) ||
                const DeepCollectionEquality()
                    .equals(other.subType, subType)) &&
            (identical(other.ageRating, ageRating) ||
                const DeepCollectionEquality()
                    .equals(other.ageRating, ageRating)) &&
            (identical(other.channelId, channelId) ||
                const DeepCollectionEquality()
                    .equals(other.channelId, channelId)) &&
            (identical(other.startTime, startTime) ||
                const DeepCollectionEquality()
                    .equals(other.startTime, startTime)) &&
            (identical(other.endTime, endTime) ||
                const DeepCollectionEquality()
                    .equals(other.endTime, endTime)) &&
            (identical(other.duration, duration) ||
                const DeepCollectionEquality()
                    .equals(other.duration, duration)) &&
            (identical(other.bookmark, bookmark) ||
                const DeepCollectionEquality()
                    .equals(other.bookmark, bookmark)) &&
            (identical(other.priceDisplay, priceDisplay) ||
                const DeepCollectionEquality()
                    .equals(other.priceDisplay, priceDisplay)) &&
            (identical(other.minPriceDisplay, minPriceDisplay) ||
                const DeepCollectionEquality()
                    .equals(other.minPriceDisplay, minPriceDisplay)) &&
            (identical(other.tvodEntitlementEnd, tvodEntitlementEnd) ||
                const DeepCollectionEquality()
                    .equals(other.tvodEntitlementEnd, tvodEntitlementEnd)) &&
            (identical(other.entitlementEnd, entitlementEnd) ||
                const DeepCollectionEquality()
                    .equals(other.entitlementEnd, entitlementEnd)) &&
            (identical(other.isRemoved, isRemoved) ||
                const DeepCollectionEquality()
                    .equals(other.isRemoved, isRemoved)) &&
            (identical(other.isExpired, isExpired) ||
                const DeepCollectionEquality()
                    .equals(other.isExpired, isExpired)) &&
            (identical(other.isBoxset, isBoxset) ||
                const DeepCollectionEquality()
                    .equals(other.isBoxset, isBoxset)) &&
            (identical(other.seasonNumber, seasonNumber) ||
                const DeepCollectionEquality()
                    .equals(other.seasonNumber, seasonNumber)) &&
            (identical(other.episodeNumber, episodeNumber) ||
                const DeepCollectionEquality()
                    .equals(other.episodeNumber, episodeNumber)) &&
            (identical(other.recordingState, recordingState) ||
                const DeepCollectionEquality()
                    .equals(other.recordingState, recordingState)) &&
            (identical(other.seasonCount, seasonCount) ||
                const DeepCollectionEquality()
                    .equals(other.seasonCount, seasonCount)) &&
            (identical(other.expirationDate, expirationDate) ||
                const DeepCollectionEquality()
                    .equals(other.expirationDate, expirationDate)) &&
            (identical(other.earliestBroadcastStartTime, earliestBroadcastStartTime) || const DeepCollectionEquality().equals(other.earliestBroadcastStartTime, earliestBroadcastStartTime)) &&
            (identical(other.isPurchased, isPurchased) || const DeepCollectionEquality().equals(other.isPurchased, isPurchased)) &&
            (identical(other.seriesId, seriesId) || const DeepCollectionEquality().equals(other.seriesId, seriesId)) &&
            (identical(other.rootId, rootId) || const DeepCollectionEquality().equals(other.rootId, rootId)) &&
            (identical(other.providerId, providerId) || const DeepCollectionEquality().equals(other.providerId, providerId)) &&
            (identical(other.interacted, interacted) || const DeepCollectionEquality().equals(other.interacted, interacted)) &&
            (identical(other.image, image) || const DeepCollectionEquality().equals(other.image, image)) &&
            (identical(other.externalAppId, externalAppId) || const DeepCollectionEquality().equals(other.externalAppId, externalAppId)) &&
            (identical(other.externalAppDeepLink, externalAppDeepLink) || const DeepCollectionEquality().equals(other.externalAppDeepLink, externalAppDeepLink)) &&
            (identical(other.imageVersion, imageVersion) || const DeepCollectionEquality().equals(other.imageVersion, imageVersion)) &&
            (identical(other.entitlementState, entitlementState) || const DeepCollectionEquality().equals(other.entitlementState, entitlementState)) &&
            (identical(other.goPlayable, goPlayable) || const DeepCollectionEquality().equals(other.goPlayable, goPlayable)) &&
            (identical(other.episodeName, episodeName) || const DeepCollectionEquality().equals(other.episodeName, episodeName)) &&
            (identical(other.url, url) || const DeepCollectionEquality().equals(other.url, url)) &&
            (identical(other.mostRelevantEpisode, mostRelevantEpisode) || const DeepCollectionEquality().equals(other.mostRelevantEpisode, mostRelevantEpisode)) &&
            (identical(other.isSplitProgram, isSplitProgram) || const DeepCollectionEquality().equals(other.isSplitProgram, isSplitProgram)) &&
            (identical(other.shortDescription, shortDescription) || const DeepCollectionEquality().equals(other.shortDescription, shortDescription)) &&
            (identical(other.genres, genres) || const DeepCollectionEquality().equals(other.genres, genres)) &&
            (identical(other.fromRemoteBookmark, fromRemoteBookmark) || const DeepCollectionEquality().equals(other.fromRemoteBookmark, fromRemoteBookmark)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(title) ^
      const DeepCollectionEquality().hash(type) ^
      const DeepCollectionEquality().hash(brandingProviderId) ^
      const DeepCollectionEquality().hash(subType) ^
      const DeepCollectionEquality().hash(ageRating) ^
      const DeepCollectionEquality().hash(channelId) ^
      const DeepCollectionEquality().hash(startTime) ^
      const DeepCollectionEquality().hash(endTime) ^
      const DeepCollectionEquality().hash(duration) ^
      const DeepCollectionEquality().hash(bookmark) ^
      const DeepCollectionEquality().hash(priceDisplay) ^
      const DeepCollectionEquality().hash(minPriceDisplay) ^
      const DeepCollectionEquality().hash(tvodEntitlementEnd) ^
      const DeepCollectionEquality().hash(entitlementEnd) ^
      const DeepCollectionEquality().hash(isRemoved) ^
      const DeepCollectionEquality().hash(isExpired) ^
      const DeepCollectionEquality().hash(isBoxset) ^
      const DeepCollectionEquality().hash(seasonNumber) ^
      const DeepCollectionEquality().hash(episodeNumber) ^
      const DeepCollectionEquality().hash(recordingState) ^
      const DeepCollectionEquality().hash(seasonCount) ^
      const DeepCollectionEquality().hash(expirationDate) ^
      const DeepCollectionEquality().hash(earliestBroadcastStartTime) ^
      const DeepCollectionEquality().hash(isPurchased) ^
      const DeepCollectionEquality().hash(seriesId) ^
      const DeepCollectionEquality().hash(rootId) ^
      const DeepCollectionEquality().hash(providerId) ^
      const DeepCollectionEquality().hash(interacted) ^
      const DeepCollectionEquality().hash(image) ^
      const DeepCollectionEquality().hash(externalAppId) ^
      const DeepCollectionEquality().hash(externalAppDeepLink) ^
      const DeepCollectionEquality().hash(imageVersion) ^
      const DeepCollectionEquality().hash(entitlementState) ^
      const DeepCollectionEquality().hash(goPlayable) ^
      const DeepCollectionEquality().hash(episodeName) ^
      const DeepCollectionEquality().hash(url) ^
      const DeepCollectionEquality().hash(mostRelevantEpisode) ^
      const DeepCollectionEquality().hash(isSplitProgram) ^
      const DeepCollectionEquality().hash(shortDescription) ^
      const DeepCollectionEquality().hash(genres) ^
      const DeepCollectionEquality().hash(fromRemoteBookmark) ^
      runtimeType.hashCode;
}

extension $ScreenItemExtension on ScreenItem {
  ScreenItem copyWith(
      {String? id,
      String? title,
      String? type,
      String? brandingProviderId,
      enums.ScreenItemSubType? subType,
      String? ageRating,
      String? channelId,
      DateTime? startTime,
      DateTime? endTime,
      int? duration,
      int? bookmark,
      String? priceDisplay,
      String? minPriceDisplay,
      DateTime? tvodEntitlementEnd,
      DateTime? entitlementEnd,
      bool? isRemoved,
      bool? isExpired,
      bool? isBoxset,
      int? seasonNumber,
      int? episodeNumber,
      String? recordingState,
      int? seasonCount,
      DateTime? expirationDate,
      DateTime? earliestBroadcastStartTime,
      bool? isPurchased,
      String? seriesId,
      String? rootId,
      String? providerId,
      bool? interacted,
      String? image,
      String? externalAppId,
      String? externalAppDeepLink,
      String? imageVersion,
      enums.ScreenItemEntitlementState? entitlementState,
      bool? goPlayable,
      String? episodeName,
      String? url,
      String? mostRelevantEpisode,
      bool? isSplitProgram,
      String? shortDescription,
      List<String>? genres,
      bool? fromRemoteBookmark}) {
    return ScreenItem(
        id: id ?? this.id,
        title: title ?? this.title,
        type: type ?? this.type,
        brandingProviderId: brandingProviderId ?? this.brandingProviderId,
        subType: subType ?? this.subType,
        ageRating: ageRating ?? this.ageRating,
        channelId: channelId ?? this.channelId,
        startTime: startTime ?? this.startTime,
        endTime: endTime ?? this.endTime,
        duration: duration ?? this.duration,
        bookmark: bookmark ?? this.bookmark,
        priceDisplay: priceDisplay ?? this.priceDisplay,
        minPriceDisplay: minPriceDisplay ?? this.minPriceDisplay,
        tvodEntitlementEnd: tvodEntitlementEnd ?? this.tvodEntitlementEnd,
        entitlementEnd: entitlementEnd ?? this.entitlementEnd,
        isRemoved: isRemoved ?? this.isRemoved,
        isExpired: isExpired ?? this.isExpired,
        isBoxset: isBoxset ?? this.isBoxset,
        seasonNumber: seasonNumber ?? this.seasonNumber,
        episodeNumber: episodeNumber ?? this.episodeNumber,
        recordingState: recordingState ?? this.recordingState,
        seasonCount: seasonCount ?? this.seasonCount,
        expirationDate: expirationDate ?? this.expirationDate,
        earliestBroadcastStartTime:
            earliestBroadcastStartTime ?? this.earliestBroadcastStartTime,
        isPurchased: isPurchased ?? this.isPurchased,
        seriesId: seriesId ?? this.seriesId,
        rootId: rootId ?? this.rootId,
        providerId: providerId ?? this.providerId,
        interacted: interacted ?? this.interacted,
        image: image ?? this.image,
        externalAppId: externalAppId ?? this.externalAppId,
        externalAppDeepLink: externalAppDeepLink ?? this.externalAppDeepLink,
        imageVersion: imageVersion ?? this.imageVersion,
        entitlementState: entitlementState ?? this.entitlementState,
        goPlayable: goPlayable ?? this.goPlayable,
        episodeName: episodeName ?? this.episodeName,
        url: url ?? this.url,
        mostRelevantEpisode: mostRelevantEpisode ?? this.mostRelevantEpisode,
        isSplitProgram: isSplitProgram ?? this.isSplitProgram,
        shortDescription: shortDescription ?? this.shortDescription,
        genres: genres ?? this.genres,
        fromRemoteBookmark: fromRemoteBookmark ?? this.fromRemoteBookmark);
  }

  ScreenItem copyWithWrapped(
      {Wrapped<String?>? id,
      Wrapped<String?>? title,
      Wrapped<String?>? type,
      Wrapped<String?>? brandingProviderId,
      Wrapped<enums.ScreenItemSubType?>? subType,
      Wrapped<String?>? ageRating,
      Wrapped<String?>? channelId,
      Wrapped<DateTime?>? startTime,
      Wrapped<DateTime?>? endTime,
      Wrapped<int?>? duration,
      Wrapped<int?>? bookmark,
      Wrapped<String?>? priceDisplay,
      Wrapped<String?>? minPriceDisplay,
      Wrapped<DateTime?>? tvodEntitlementEnd,
      Wrapped<DateTime?>? entitlementEnd,
      Wrapped<bool?>? isRemoved,
      Wrapped<bool?>? isExpired,
      Wrapped<bool?>? isBoxset,
      Wrapped<int?>? seasonNumber,
      Wrapped<int?>? episodeNumber,
      Wrapped<String?>? recordingState,
      Wrapped<int?>? seasonCount,
      Wrapped<DateTime?>? expirationDate,
      Wrapped<DateTime?>? earliestBroadcastStartTime,
      Wrapped<bool?>? isPurchased,
      Wrapped<String?>? seriesId,
      Wrapped<String?>? rootId,
      Wrapped<String?>? providerId,
      Wrapped<bool?>? interacted,
      Wrapped<String?>? image,
      Wrapped<String?>? externalAppId,
      Wrapped<String?>? externalAppDeepLink,
      Wrapped<String?>? imageVersion,
      Wrapped<enums.ScreenItemEntitlementState?>? entitlementState,
      Wrapped<bool?>? goPlayable,
      Wrapped<String?>? episodeName,
      Wrapped<String?>? url,
      Wrapped<String?>? mostRelevantEpisode,
      Wrapped<bool?>? isSplitProgram,
      Wrapped<String?>? shortDescription,
      Wrapped<List<String>?>? genres,
      Wrapped<bool?>? fromRemoteBookmark}) {
    return ScreenItem(
        id: (id != null ? id.value : this.id),
        title: (title != null ? title.value : this.title),
        type: (type != null ? type.value : this.type),
        brandingProviderId: (brandingProviderId != null
            ? brandingProviderId.value
            : this.brandingProviderId),
        subType: (subType != null ? subType.value : this.subType),
        ageRating: (ageRating != null ? ageRating.value : this.ageRating),
        channelId: (channelId != null ? channelId.value : this.channelId),
        startTime: (startTime != null ? startTime.value : this.startTime),
        endTime: (endTime != null ? endTime.value : this.endTime),
        duration: (duration != null ? duration.value : this.duration),
        bookmark: (bookmark != null ? bookmark.value : this.bookmark),
        priceDisplay:
            (priceDisplay != null ? priceDisplay.value : this.priceDisplay),
        minPriceDisplay: (minPriceDisplay != null
            ? minPriceDisplay.value
            : this.minPriceDisplay),
        tvodEntitlementEnd: (tvodEntitlementEnd != null
            ? tvodEntitlementEnd.value
            : this.tvodEntitlementEnd),
        entitlementEnd: (entitlementEnd != null
            ? entitlementEnd.value
            : this.entitlementEnd),
        isRemoved: (isRemoved != null ? isRemoved.value : this.isRemoved),
        isExpired: (isExpired != null ? isExpired.value : this.isExpired),
        isBoxset: (isBoxset != null ? isBoxset.value : this.isBoxset),
        seasonNumber:
            (seasonNumber != null ? seasonNumber.value : this.seasonNumber),
        episodeNumber:
            (episodeNumber != null ? episodeNumber.value : this.episodeNumber),
        recordingState: (recordingState != null
            ? recordingState.value
            : this.recordingState),
        seasonCount:
            (seasonCount != null ? seasonCount.value : this.seasonCount),
        expirationDate: (expirationDate != null
            ? expirationDate.value
            : this.expirationDate),
        earliestBroadcastStartTime: (earliestBroadcastStartTime != null
            ? earliestBroadcastStartTime.value
            : this.earliestBroadcastStartTime),
        isPurchased:
            (isPurchased != null ? isPurchased.value : this.isPurchased),
        seriesId: (seriesId != null ? seriesId.value : this.seriesId),
        rootId: (rootId != null ? rootId.value : this.rootId),
        providerId: (providerId != null ? providerId.value : this.providerId),
        interacted: (interacted != null ? interacted.value : this.interacted),
        image: (image != null ? image.value : this.image),
        externalAppId:
            (externalAppId != null ? externalAppId.value : this.externalAppId),
        externalAppDeepLink: (externalAppDeepLink != null
            ? externalAppDeepLink.value
            : this.externalAppDeepLink),
        imageVersion:
            (imageVersion != null ? imageVersion.value : this.imageVersion),
        entitlementState: (entitlementState != null
            ? entitlementState.value
            : this.entitlementState),
        goPlayable: (goPlayable != null ? goPlayable.value : this.goPlayable),
        episodeName:
            (episodeName != null ? episodeName.value : this.episodeName),
        url: (url != null ? url.value : this.url),
        mostRelevantEpisode: (mostRelevantEpisode != null
            ? mostRelevantEpisode.value
            : this.mostRelevantEpisode),
        isSplitProgram: (isSplitProgram != null
            ? isSplitProgram.value
            : this.isSplitProgram),
        shortDescription: (shortDescription != null
            ? shortDescription.value
            : this.shortDescription),
        genres: (genres != null ? genres.value : this.genres),
        fromRemoteBookmark: (fromRemoteBookmark != null
            ? fromRemoteBookmark.value
            : this.fromRemoteBookmark));
  }
}

@JsonSerializable(explicitToJson: true)
class Aspot {
  Aspot({
    this.id,
    this.type,
    this.isBoxset,
    this.brandingProviderId,
    this.imageVersion,
    this.seriesId,
    this.title,
    this.yearOfProduction,
    this.genres,
    this.subType,
    this.seasonCount,
    this.channelId,
    this.entitlementState,
    this.startTime,
    this.endTime,
    this.earliestBroadcastStartTime,
  });

  factory Aspot.fromJson(Map<String, dynamic> json) => _$AspotFromJson(json);

  static const toJsonFactory = _$AspotToJson;
  Map<String, dynamic> toJson() => _$AspotToJson(this);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String? id;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  @JsonKey(name: 'isBoxset', includeIfNull: false)
  final bool? isBoxset;
  @JsonKey(name: 'brandingProviderId', includeIfNull: false, defaultValue: '')
  final String? brandingProviderId;
  @JsonKey(name: 'imageVersion', includeIfNull: false, defaultValue: '')
  final String? imageVersion;
  @JsonKey(name: 'seriesId', includeIfNull: false, defaultValue: '')
  final String? seriesId;
  @JsonKey(name: 'title', includeIfNull: false, defaultValue: '')
  final String? title;
  @JsonKey(name: 'yearOfProduction', includeIfNull: false, defaultValue: '')
  final String? yearOfProduction;
  @JsonKey(name: 'genres', includeIfNull: false, defaultValue: <String>[])
  final List<String>? genres;
  @JsonKey(
    name: 'subType',
    includeIfNull: false,
    toJson: aspotSubTypeToJson,
    fromJson: aspotSubTypeFromJson,
  )
  final enums.AspotSubType? subType;
  @JsonKey(name: 'seasonCount', includeIfNull: false)
  final int? seasonCount;
  @JsonKey(name: 'channelId', includeIfNull: false, defaultValue: '')
  final String? channelId;
  @JsonKey(
    name: 'entitlementState',
    includeIfNull: false,
    toJson: aspotEntitlementStateToJson,
    fromJson: aspotEntitlementStateFromJson,
  )
  final enums.AspotEntitlementState? entitlementState;
  @JsonKey(name: 'startTime', includeIfNull: false)
  final DateTime? startTime;
  @JsonKey(name: 'endTime', includeIfNull: false)
  final DateTime? endTime;
  @JsonKey(name: 'earliestBroadcastStartTime', includeIfNull: false)
  final DateTime? earliestBroadcastStartTime;
  static const fromJsonFactory = _$AspotFromJson;

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is Aspot &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)) &&
            (identical(other.isBoxset, isBoxset) ||
                const DeepCollectionEquality()
                    .equals(other.isBoxset, isBoxset)) &&
            (identical(other.brandingProviderId, brandingProviderId) ||
                const DeepCollectionEquality()
                    .equals(other.brandingProviderId, brandingProviderId)) &&
            (identical(other.imageVersion, imageVersion) ||
                const DeepCollectionEquality()
                    .equals(other.imageVersion, imageVersion)) &&
            (identical(other.seriesId, seriesId) ||
                const DeepCollectionEquality()
                    .equals(other.seriesId, seriesId)) &&
            (identical(other.title, title) ||
                const DeepCollectionEquality().equals(other.title, title)) &&
            (identical(other.yearOfProduction, yearOfProduction) ||
                const DeepCollectionEquality()
                    .equals(other.yearOfProduction, yearOfProduction)) &&
            (identical(other.genres, genres) ||
                const DeepCollectionEquality().equals(other.genres, genres)) &&
            (identical(other.subType, subType) ||
                const DeepCollectionEquality()
                    .equals(other.subType, subType)) &&
            (identical(other.seasonCount, seasonCount) ||
                const DeepCollectionEquality()
                    .equals(other.seasonCount, seasonCount)) &&
            (identical(other.channelId, channelId) ||
                const DeepCollectionEquality()
                    .equals(other.channelId, channelId)) &&
            (identical(other.entitlementState, entitlementState) ||
                const DeepCollectionEquality()
                    .equals(other.entitlementState, entitlementState)) &&
            (identical(other.startTime, startTime) ||
                const DeepCollectionEquality()
                    .equals(other.startTime, startTime)) &&
            (identical(other.endTime, endTime) ||
                const DeepCollectionEquality()
                    .equals(other.endTime, endTime)) &&
            (identical(other.earliestBroadcastStartTime,
                    earliestBroadcastStartTime) ||
                const DeepCollectionEquality().equals(
                    other.earliestBroadcastStartTime,
                    earliestBroadcastStartTime)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(type) ^
      const DeepCollectionEquality().hash(isBoxset) ^
      const DeepCollectionEquality().hash(brandingProviderId) ^
      const DeepCollectionEquality().hash(imageVersion) ^
      const DeepCollectionEquality().hash(seriesId) ^
      const DeepCollectionEquality().hash(title) ^
      const DeepCollectionEquality().hash(yearOfProduction) ^
      const DeepCollectionEquality().hash(genres) ^
      const DeepCollectionEquality().hash(subType) ^
      const DeepCollectionEquality().hash(seasonCount) ^
      const DeepCollectionEquality().hash(channelId) ^
      const DeepCollectionEquality().hash(entitlementState) ^
      const DeepCollectionEquality().hash(startTime) ^
      const DeepCollectionEquality().hash(endTime) ^
      const DeepCollectionEquality().hash(earliestBroadcastStartTime) ^
      runtimeType.hashCode;
}

extension $AspotExtension on Aspot {
  Aspot copyWith(
      {String? id,
      String? type,
      bool? isBoxset,
      String? brandingProviderId,
      String? imageVersion,
      String? seriesId,
      String? title,
      String? yearOfProduction,
      List<String>? genres,
      enums.AspotSubType? subType,
      int? seasonCount,
      String? channelId,
      enums.AspotEntitlementState? entitlementState,
      DateTime? startTime,
      DateTime? endTime,
      DateTime? earliestBroadcastStartTime}) {
    return Aspot(
        id: id ?? this.id,
        type: type ?? this.type,
        isBoxset: isBoxset ?? this.isBoxset,
        brandingProviderId: brandingProviderId ?? this.brandingProviderId,
        imageVersion: imageVersion ?? this.imageVersion,
        seriesId: seriesId ?? this.seriesId,
        title: title ?? this.title,
        yearOfProduction: yearOfProduction ?? this.yearOfProduction,
        genres: genres ?? this.genres,
        subType: subType ?? this.subType,
        seasonCount: seasonCount ?? this.seasonCount,
        channelId: channelId ?? this.channelId,
        entitlementState: entitlementState ?? this.entitlementState,
        startTime: startTime ?? this.startTime,
        endTime: endTime ?? this.endTime,
        earliestBroadcastStartTime:
            earliestBroadcastStartTime ?? this.earliestBroadcastStartTime);
  }

  Aspot copyWithWrapped(
      {Wrapped<String?>? id,
      Wrapped<String?>? type,
      Wrapped<bool?>? isBoxset,
      Wrapped<String?>? brandingProviderId,
      Wrapped<String?>? imageVersion,
      Wrapped<String?>? seriesId,
      Wrapped<String?>? title,
      Wrapped<String?>? yearOfProduction,
      Wrapped<List<String>?>? genres,
      Wrapped<enums.AspotSubType?>? subType,
      Wrapped<int?>? seasonCount,
      Wrapped<String?>? channelId,
      Wrapped<enums.AspotEntitlementState?>? entitlementState,
      Wrapped<DateTime?>? startTime,
      Wrapped<DateTime?>? endTime,
      Wrapped<DateTime?>? earliestBroadcastStartTime}) {
    return Aspot(
        id: (id != null ? id.value : this.id),
        type: (type != null ? type.value : this.type),
        isBoxset: (isBoxset != null ? isBoxset.value : this.isBoxset),
        brandingProviderId: (brandingProviderId != null
            ? brandingProviderId.value
            : this.brandingProviderId),
        imageVersion:
            (imageVersion != null ? imageVersion.value : this.imageVersion),
        seriesId: (seriesId != null ? seriesId.value : this.seriesId),
        title: (title != null ? title.value : this.title),
        yearOfProduction: (yearOfProduction != null
            ? yearOfProduction.value
            : this.yearOfProduction),
        genres: (genres != null ? genres.value : this.genres),
        subType: (subType != null ? subType.value : this.subType),
        seasonCount:
            (seasonCount != null ? seasonCount.value : this.seasonCount),
        channelId: (channelId != null ? channelId.value : this.channelId),
        entitlementState: (entitlementState != null
            ? entitlementState.value
            : this.entitlementState),
        startTime: (startTime != null ? startTime.value : this.startTime),
        endTime: (endTime != null ? endTime.value : this.endTime),
        earliestBroadcastStartTime: (earliestBroadcastStartTime != null
            ? earliestBroadcastStartTime.value
            : this.earliestBroadcastStartTime));
  }
}

typedef Structure = List<StructureItem>;

@JsonSerializable(explicitToJson: true)
class StructureItem {
  StructureItem({
    required this.id,
    this.type,
    this.title,
    this.layout,
    this.subcollections,
  });

  factory StructureItem.fromJson(Map<String, dynamic> json) =>
      _$StructureItemFromJson(json);

  static const toJsonFactory = _$StructureItemToJson;
  Map<String, dynamic> toJson() => _$StructureItemToJson(this);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String id;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  @JsonKey(name: 'title', includeIfNull: false, defaultValue: '')
  final String? title;
  @JsonKey(name: 'layout', includeIfNull: false, defaultValue: '')
  final String? layout;
  @JsonKey(
      name: 'subcollections',
      includeIfNull: false,
      defaultValue: <StructureSubcollection>[])
  final List<StructureSubcollection>? subcollections;
  static const fromJsonFactory = _$StructureItemFromJson;

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is StructureItem &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)) &&
            (identical(other.title, title) ||
                const DeepCollectionEquality().equals(other.title, title)) &&
            (identical(other.layout, layout) ||
                const DeepCollectionEquality().equals(other.layout, layout)) &&
            (identical(other.subcollections, subcollections) ||
                const DeepCollectionEquality()
                    .equals(other.subcollections, subcollections)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(type) ^
      const DeepCollectionEquality().hash(title) ^
      const DeepCollectionEquality().hash(layout) ^
      const DeepCollectionEquality().hash(subcollections) ^
      runtimeType.hashCode;
}

extension $StructureItemExtension on StructureItem {
  StructureItem copyWith(
      {String? id,
      String? type,
      String? title,
      String? layout,
      List<StructureSubcollection>? subcollections}) {
    return StructureItem(
        id: id ?? this.id,
        type: type ?? this.type,
        title: title ?? this.title,
        layout: layout ?? this.layout,
        subcollections: subcollections ?? this.subcollections);
  }

  StructureItem copyWithWrapped(
      {Wrapped<String>? id,
      Wrapped<String?>? type,
      Wrapped<String?>? title,
      Wrapped<String?>? layout,
      Wrapped<List<StructureSubcollection>?>? subcollections}) {
    return StructureItem(
        id: (id != null ? id.value : this.id),
        type: (type != null ? type.value : this.type),
        title: (title != null ? title.value : this.title),
        layout: (layout != null ? layout.value : this.layout),
        subcollections: (subcollections != null
            ? subcollections.value
            : this.subcollections));
  }
}

@JsonSerializable(explicitToJson: true)
class StructureSubcollection {
  StructureSubcollection({
    required this.id,
    this.type,
    this.title,
    this.layout,
    this.order,
    this.appId,
  });

  factory StructureSubcollection.fromJson(Map<String, dynamic> json) =>
      _$StructureSubcollectionFromJson(json);

  static const toJsonFactory = _$StructureSubcollectionToJson;
  Map<String, dynamic> toJson() => _$StructureSubcollectionToJson(this);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String id;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  @JsonKey(name: 'title', includeIfNull: false, defaultValue: '')
  final String? title;
  @JsonKey(name: 'layout', includeIfNull: false, defaultValue: '')
  final String? layout;
  @JsonKey(name: 'order', includeIfNull: false, defaultValue: '')
  final String? order;
  @JsonKey(name: 'appId', includeIfNull: false, defaultValue: '')
  final String? appId;
  static const fromJsonFactory = _$StructureSubcollectionFromJson;

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is StructureSubcollection &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)) &&
            (identical(other.title, title) ||
                const DeepCollectionEquality().equals(other.title, title)) &&
            (identical(other.layout, layout) ||
                const DeepCollectionEquality().equals(other.layout, layout)) &&
            (identical(other.order, order) ||
                const DeepCollectionEquality().equals(other.order, order)) &&
            (identical(other.appId, appId) ||
                const DeepCollectionEquality().equals(other.appId, appId)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(type) ^
      const DeepCollectionEquality().hash(title) ^
      const DeepCollectionEquality().hash(layout) ^
      const DeepCollectionEquality().hash(order) ^
      const DeepCollectionEquality().hash(appId) ^
      runtimeType.hashCode;
}

extension $StructureSubcollectionExtension on StructureSubcollection {
  StructureSubcollection copyWith(
      {String? id,
      String? type,
      String? title,
      String? layout,
      String? order,
      String? appId}) {
    return StructureSubcollection(
        id: id ?? this.id,
        type: type ?? this.type,
        title: title ?? this.title,
        layout: layout ?? this.layout,
        order: order ?? this.order,
        appId: appId ?? this.appId);
  }

  StructureSubcollection copyWithWrapped(
      {Wrapped<String>? id,
      Wrapped<String?>? type,
      Wrapped<String?>? title,
      Wrapped<String?>? layout,
      Wrapped<String?>? order,
      Wrapped<String?>? appId}) {
    return StructureSubcollection(
        id: (id != null ? id.value : this.id),
        type: (type != null ? type.value : this.type),
        title: (title != null ? title.value : this.title),
        layout: (layout != null ? layout.value : this.layout),
        order: (order != null ? order.value : this.order),
        appId: (appId != null ? appId.value : this.appId));
  }
}

@JsonSerializable(explicitToJson: true)
class StructureLink {
  StructureLink({
    this.id,
    this.type,
    this.rootId,
    this.provider,
    this.url,
    this.order,
  });

  factory StructureLink.fromJson(Map<String, dynamic> json) =>
      _$StructureLinkFromJson(json);

  static const toJsonFactory = _$StructureLinkToJson;
  Map<String, dynamic> toJson() => _$StructureLinkToJson(this);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String? id;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String? type;
  @JsonKey(name: 'rootId', includeIfNull: false, defaultValue: '')
  final String? rootId;
  @JsonKey(name: 'provider', includeIfNull: false, defaultValue: '')
  final String? provider;
  @JsonKey(name: 'url', includeIfNull: false, defaultValue: '')
  final String? url;
  @JsonKey(
    name: 'order',
    includeIfNull: false,
    toJson: structureLinkOrderToJson,
    fromJson: structureLinkOrderFromJson,
  )
  final enums.StructureLinkOrder? order;
  static const fromJsonFactory = _$StructureLinkFromJson;

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is StructureLink &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)) &&
            (identical(other.rootId, rootId) ||
                const DeepCollectionEquality().equals(other.rootId, rootId)) &&
            (identical(other.provider, provider) ||
                const DeepCollectionEquality()
                    .equals(other.provider, provider)) &&
            (identical(other.url, url) ||
                const DeepCollectionEquality().equals(other.url, url)) &&
            (identical(other.order, order) ||
                const DeepCollectionEquality().equals(other.order, order)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(type) ^
      const DeepCollectionEquality().hash(rootId) ^
      const DeepCollectionEquality().hash(provider) ^
      const DeepCollectionEquality().hash(url) ^
      const DeepCollectionEquality().hash(order) ^
      runtimeType.hashCode;
}

extension $StructureLinkExtension on StructureLink {
  StructureLink copyWith(
      {String? id,
      String? type,
      String? rootId,
      String? provider,
      String? url,
      enums.StructureLinkOrder? order}) {
    return StructureLink(
        id: id ?? this.id,
        type: type ?? this.type,
        rootId: rootId ?? this.rootId,
        provider: provider ?? this.provider,
        url: url ?? this.url,
        order: order ?? this.order);
  }

  StructureLink copyWithWrapped(
      {Wrapped<String?>? id,
      Wrapped<String?>? type,
      Wrapped<String?>? rootId,
      Wrapped<String?>? provider,
      Wrapped<String?>? url,
      Wrapped<enums.StructureLinkOrder?>? order}) {
    return StructureLink(
        id: (id != null ? id.value : this.id),
        type: (type != null ? type.value : this.type),
        rootId: (rootId != null ? rootId.value : this.rootId),
        provider: (provider != null ? provider.value : this.provider),
        url: (url != null ? url.value : this.url),
        order: (order != null ? order.value : this.order));
  }
}

@JsonSerializable(explicitToJson: true)
class TopShelf {
  TopShelf({
    required this.collections,
  });

  factory TopShelf.fromJson(Map<String, dynamic> json) =>
      _$TopShelfFromJson(json);

  static const toJsonFactory = _$TopShelfToJson;
  Map<String, dynamic> toJson() => _$TopShelfToJson(this);

  @JsonKey(
      name: 'collections',
      includeIfNull: false,
      defaultValue: <ScreenCollection>[])
  final List<ScreenCollection> collections;
  static const fromJsonFactory = _$TopShelfFromJson;

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is TopShelf &&
            (identical(other.collections, collections) ||
                const DeepCollectionEquality()
                    .equals(other.collections, collections)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(collections) ^ runtimeType.hashCode;
}

extension $TopShelfExtension on TopShelf {
  TopShelf copyWith({List<ScreenCollection>? collections}) {
    return TopShelf(collections: collections ?? this.collections);
  }

  TopShelf copyWithWrapped({Wrapped<List<ScreenCollection>>? collections}) {
    return TopShelf(
        collections:
            (collections != null ? collections.value : this.collections));
  }
}

@JsonSerializable(explicitToJson: true)
class ErrorResponse {
  ErrorResponse({
    this.error,
  });

  factory ErrorResponse.fromJson(Map<String, dynamic> json) =>
      _$ErrorResponseFromJson(json);

  static const toJsonFactory = _$ErrorResponseToJson;
  Map<String, dynamic> toJson() => _$ErrorResponseToJson(this);

  @JsonKey(name: 'error', includeIfNull: false)
  final ErrorResponse$Error? error;
  static const fromJsonFactory = _$ErrorResponseFromJson;

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ErrorResponse &&
            (identical(other.error, error) ||
                const DeepCollectionEquality().equals(other.error, error)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(error) ^ runtimeType.hashCode;
}

extension $ErrorResponseExtension on ErrorResponse {
  ErrorResponse copyWith({ErrorResponse$Error? error}) {
    return ErrorResponse(error: error ?? this.error);
  }

  ErrorResponse copyWithWrapped({Wrapped<ErrorResponse$Error?>? error}) {
    return ErrorResponse(error: (error != null ? error.value : this.error));
  }
}

@JsonSerializable(explicitToJson: true)
class ErrorResponse$Error {
  ErrorResponse$Error({
    this.httpStatusCode,
    this.statusCode,
    this.message,
    this.details,
    this.correlationId,
  });

  factory ErrorResponse$Error.fromJson(Map<String, dynamic> json) =>
      _$ErrorResponse$ErrorFromJson(json);

  static const toJsonFactory = _$ErrorResponse$ErrorToJson;
  Map<String, dynamic> toJson() => _$ErrorResponse$ErrorToJson(this);

  @JsonKey(name: 'httpStatusCode', includeIfNull: false)
  final int? httpStatusCode;
  @JsonKey(name: 'statusCode', includeIfNull: false)
  final int? statusCode;
  @JsonKey(name: 'message', includeIfNull: false, defaultValue: '')
  final String? message;
  @JsonKey(name: 'details', includeIfNull: false, defaultValue: '')
  final String? details;
  @JsonKey(name: 'correlationId', includeIfNull: false, defaultValue: '')
  final String? correlationId;
  static const fromJsonFactory = _$ErrorResponse$ErrorFromJson;

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ErrorResponse$Error &&
            (identical(other.httpStatusCode, httpStatusCode) ||
                const DeepCollectionEquality()
                    .equals(other.httpStatusCode, httpStatusCode)) &&
            (identical(other.statusCode, statusCode) ||
                const DeepCollectionEquality()
                    .equals(other.statusCode, statusCode)) &&
            (identical(other.message, message) ||
                const DeepCollectionEquality()
                    .equals(other.message, message)) &&
            (identical(other.details, details) ||
                const DeepCollectionEquality()
                    .equals(other.details, details)) &&
            (identical(other.correlationId, correlationId) ||
                const DeepCollectionEquality()
                    .equals(other.correlationId, correlationId)));
  }

  @override
  String toString() => jsonEncode(this);

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(httpStatusCode) ^
      const DeepCollectionEquality().hash(statusCode) ^
      const DeepCollectionEquality().hash(message) ^
      const DeepCollectionEquality().hash(details) ^
      const DeepCollectionEquality().hash(correlationId) ^
      runtimeType.hashCode;
}

extension $ErrorResponse$ErrorExtension on ErrorResponse$Error {
  ErrorResponse$Error copyWith(
      {int? httpStatusCode,
      int? statusCode,
      String? message,
      String? details,
      String? correlationId}) {
    return ErrorResponse$Error(
        httpStatusCode: httpStatusCode ?? this.httpStatusCode,
        statusCode: statusCode ?? this.statusCode,
        message: message ?? this.message,
        details: details ?? this.details,
        correlationId: correlationId ?? this.correlationId);
  }

  ErrorResponse$Error copyWithWrapped(
      {Wrapped<int?>? httpStatusCode,
      Wrapped<int?>? statusCode,
      Wrapped<String?>? message,
      Wrapped<String?>? details,
      Wrapped<String?>? correlationId}) {
    return ErrorResponse$Error(
        httpStatusCode: (httpStatusCode != null
            ? httpStatusCode.value
            : this.httpStatusCode),
        statusCode: (statusCode != null ? statusCode.value : this.statusCode),
        message: (message != null ? message.value : this.message),
        details: (details != null ? details.value : this.details),
        correlationId:
            (correlationId != null ? correlationId.value : this.correlationId));
  }
}

String? screenCollectionLayoutToJson(
    enums.ScreenCollectionLayout? screenCollectionLayout) {
  return screenCollectionLayout?.value;
}

enums.ScreenCollectionLayout screenCollectionLayoutFromJson(
  Object? screenCollectionLayout, [
  enums.ScreenCollectionLayout? defaultValue,
]) {
  return enums.ScreenCollectionLayout.values
          .firstWhereOrNull((e) => e.value == screenCollectionLayout) ??
      defaultValue ??
      enums.ScreenCollectionLayout.swaggerGeneratedUnknown;
}

List<String> screenCollectionLayoutListToJson(
    List<enums.ScreenCollectionLayout>? screenCollectionLayout) {
  if (screenCollectionLayout == null) {
    return [];
  }

  return screenCollectionLayout.map((e) => e.value!).toList();
}

List<enums.ScreenCollectionLayout> screenCollectionLayoutListFromJson(
  List? screenCollectionLayout, [
  List<enums.ScreenCollectionLayout>? defaultValue,
]) {
  if (screenCollectionLayout == null) {
    return defaultValue ?? [];
  }

  return screenCollectionLayout
      .map((e) => screenCollectionLayoutFromJson(e.toString()))
      .toList();
}

List<enums.ScreenCollectionLayout>? screenCollectionLayoutNullableListFromJson(
  List? screenCollectionLayout, [
  List<enums.ScreenCollectionLayout>? defaultValue,
]) {
  if (screenCollectionLayout == null) {
    return defaultValue;
  }

  return screenCollectionLayout
      .map((e) => screenCollectionLayoutFromJson(e.toString()))
      .toList();
}

String? screenItemSubTypeToJson(enums.ScreenItemSubType? screenItemSubType) {
  return screenItemSubType?.value;
}

enums.ScreenItemSubType screenItemSubTypeFromJson(
  Object? screenItemSubType, [
  enums.ScreenItemSubType? defaultValue,
]) {
  return enums.ScreenItemSubType.values
          .firstWhereOrNull((e) => e.value == screenItemSubType) ??
      defaultValue ??
      enums.ScreenItemSubType.swaggerGeneratedUnknown;
}

List<String> screenItemSubTypeListToJson(
    List<enums.ScreenItemSubType>? screenItemSubType) {
  if (screenItemSubType == null) {
    return [];
  }

  return screenItemSubType.map((e) => e.value!).toList();
}

List<enums.ScreenItemSubType> screenItemSubTypeListFromJson(
  List? screenItemSubType, [
  List<enums.ScreenItemSubType>? defaultValue,
]) {
  if (screenItemSubType == null) {
    return defaultValue ?? [];
  }

  return screenItemSubType
      .map((e) => screenItemSubTypeFromJson(e.toString()))
      .toList();
}

List<enums.ScreenItemSubType>? screenItemSubTypeNullableListFromJson(
  List? screenItemSubType, [
  List<enums.ScreenItemSubType>? defaultValue,
]) {
  if (screenItemSubType == null) {
    return defaultValue;
  }

  return screenItemSubType
      .map((e) => screenItemSubTypeFromJson(e.toString()))
      .toList();
}

String? screenItemEntitlementStateToJson(
    enums.ScreenItemEntitlementState? screenItemEntitlementState) {
  return screenItemEntitlementState?.value;
}

enums.ScreenItemEntitlementState screenItemEntitlementStateFromJson(
  Object? screenItemEntitlementState, [
  enums.ScreenItemEntitlementState? defaultValue,
]) {
  return enums.ScreenItemEntitlementState.values
          .firstWhereOrNull((e) => e.value == screenItemEntitlementState) ??
      defaultValue ??
      enums.ScreenItemEntitlementState.swaggerGeneratedUnknown;
}

List<String> screenItemEntitlementStateListToJson(
    List<enums.ScreenItemEntitlementState>? screenItemEntitlementState) {
  if (screenItemEntitlementState == null) {
    return [];
  }

  return screenItemEntitlementState.map((e) => e.value!).toList();
}

List<enums.ScreenItemEntitlementState> screenItemEntitlementStateListFromJson(
  List? screenItemEntitlementState, [
  List<enums.ScreenItemEntitlementState>? defaultValue,
]) {
  if (screenItemEntitlementState == null) {
    return defaultValue ?? [];
  }

  return screenItemEntitlementState
      .map((e) => screenItemEntitlementStateFromJson(e.toString()))
      .toList();
}

List<enums.ScreenItemEntitlementState>?
    screenItemEntitlementStateNullableListFromJson(
  List? screenItemEntitlementState, [
  List<enums.ScreenItemEntitlementState>? defaultValue,
]) {
  if (screenItemEntitlementState == null) {
    return defaultValue;
  }

  return screenItemEntitlementState
      .map((e) => screenItemEntitlementStateFromJson(e.toString()))
      .toList();
}

String? aspotSubTypeToJson(enums.AspotSubType? aspotSubType) {
  return aspotSubType?.value;
}

enums.AspotSubType aspotSubTypeFromJson(
  Object? aspotSubType, [
  enums.AspotSubType? defaultValue,
]) {
  return enums.AspotSubType.values
          .firstWhereOrNull((e) => e.value == aspotSubType) ??
      defaultValue ??
      enums.AspotSubType.swaggerGeneratedUnknown;
}

List<String> aspotSubTypeListToJson(List<enums.AspotSubType>? aspotSubType) {
  if (aspotSubType == null) {
    return [];
  }

  return aspotSubType.map((e) => e.value!).toList();
}

List<enums.AspotSubType> aspotSubTypeListFromJson(
  List? aspotSubType, [
  List<enums.AspotSubType>? defaultValue,
]) {
  if (aspotSubType == null) {
    return defaultValue ?? [];
  }

  return aspotSubType.map((e) => aspotSubTypeFromJson(e.toString())).toList();
}

List<enums.AspotSubType>? aspotSubTypeNullableListFromJson(
  List? aspotSubType, [
  List<enums.AspotSubType>? defaultValue,
]) {
  if (aspotSubType == null) {
    return defaultValue;
  }

  return aspotSubType.map((e) => aspotSubTypeFromJson(e.toString())).toList();
}

String? aspotEntitlementStateToJson(
    enums.AspotEntitlementState? aspotEntitlementState) {
  return aspotEntitlementState?.value;
}

enums.AspotEntitlementState aspotEntitlementStateFromJson(
  Object? aspotEntitlementState, [
  enums.AspotEntitlementState? defaultValue,
]) {
  return enums.AspotEntitlementState.values
          .firstWhereOrNull((e) => e.value == aspotEntitlementState) ??
      defaultValue ??
      enums.AspotEntitlementState.swaggerGeneratedUnknown;
}

List<String> aspotEntitlementStateListToJson(
    List<enums.AspotEntitlementState>? aspotEntitlementState) {
  if (aspotEntitlementState == null) {
    return [];
  }

  return aspotEntitlementState.map((e) => e.value!).toList();
}

List<enums.AspotEntitlementState> aspotEntitlementStateListFromJson(
  List? aspotEntitlementState, [
  List<enums.AspotEntitlementState>? defaultValue,
]) {
  if (aspotEntitlementState == null) {
    return defaultValue ?? [];
  }

  return aspotEntitlementState
      .map((e) => aspotEntitlementStateFromJson(e.toString()))
      .toList();
}

List<enums.AspotEntitlementState>? aspotEntitlementStateNullableListFromJson(
  List? aspotEntitlementState, [
  List<enums.AspotEntitlementState>? defaultValue,
]) {
  if (aspotEntitlementState == null) {
    return defaultValue;
  }

  return aspotEntitlementState
      .map((e) => aspotEntitlementStateFromJson(e.toString()))
      .toList();
}

String? structureLinkOrderToJson(enums.StructureLinkOrder? structureLinkOrder) {
  return structureLinkOrder?.value;
}

enums.StructureLinkOrder structureLinkOrderFromJson(
  Object? structureLinkOrder, [
  enums.StructureLinkOrder? defaultValue,
]) {
  return enums.StructureLinkOrder.values
          .firstWhereOrNull((e) => e.value == structureLinkOrder) ??
      defaultValue ??
      enums.StructureLinkOrder.swaggerGeneratedUnknown;
}

List<String> structureLinkOrderListToJson(
    List<enums.StructureLinkOrder>? structureLinkOrder) {
  if (structureLinkOrder == null) {
    return [];
  }

  return structureLinkOrder.map((e) => e.value!).toList();
}

List<enums.StructureLinkOrder> structureLinkOrderListFromJson(
  List? structureLinkOrder, [
  List<enums.StructureLinkOrder>? defaultValue,
]) {
  if (structureLinkOrder == null) {
    return defaultValue ?? [];
  }

  return structureLinkOrder
      .map((e) => structureLinkOrderFromJson(e.toString()))
      .toList();
}

List<enums.StructureLinkOrder>? structureLinkOrderNullableListFromJson(
  List? structureLinkOrder, [
  List<enums.StructureLinkOrder>? defaultValue,
]) {
  if (structureLinkOrder == null) {
    return defaultValue;
  }

  return structureLinkOrder
      .map((e) => structureLinkOrderFromJson(e.toString()))
      .toList();
}

String? customersCustomerIdProfilesProfileIdScreenGetFilterOnDemandToJson(
    enums.CustomersCustomerIdProfilesProfileIdScreenGetFilterOnDemand?
        customersCustomerIdProfilesProfileIdScreenGetFilterOnDemand) {
  return customersCustomerIdProfilesProfileIdScreenGetFilterOnDemand?.value;
}

enums.CustomersCustomerIdProfilesProfileIdScreenGetFilterOnDemand
    customersCustomerIdProfilesProfileIdScreenGetFilterOnDemandFromJson(
  Object? customersCustomerIdProfilesProfileIdScreenGetFilterOnDemand, [
  enums.CustomersCustomerIdProfilesProfileIdScreenGetFilterOnDemand?
      defaultValue,
]) {
  return enums
          .CustomersCustomerIdProfilesProfileIdScreenGetFilterOnDemand.values
          .firstWhereOrNull((e) =>
              e.value ==
              customersCustomerIdProfilesProfileIdScreenGetFilterOnDemand) ??
      defaultValue ??
      enums.CustomersCustomerIdProfilesProfileIdScreenGetFilterOnDemand
          .swaggerGeneratedUnknown;
}

List<String>
    customersCustomerIdProfilesProfileIdScreenGetFilterOnDemandListToJson(
        List<enums.CustomersCustomerIdProfilesProfileIdScreenGetFilterOnDemand>?
            customersCustomerIdProfilesProfileIdScreenGetFilterOnDemand) {
  if (customersCustomerIdProfilesProfileIdScreenGetFilterOnDemand == null) {
    return [];
  }

  return customersCustomerIdProfilesProfileIdScreenGetFilterOnDemand
      .map((e) => e.value!)
      .toList();
}

List<enums.CustomersCustomerIdProfilesProfileIdScreenGetFilterOnDemand>
    customersCustomerIdProfilesProfileIdScreenGetFilterOnDemandListFromJson(
  List? customersCustomerIdProfilesProfileIdScreenGetFilterOnDemand, [
  List<enums.CustomersCustomerIdProfilesProfileIdScreenGetFilterOnDemand>?
      defaultValue,
]) {
  if (customersCustomerIdProfilesProfileIdScreenGetFilterOnDemand == null) {
    return defaultValue ?? [];
  }

  return customersCustomerIdProfilesProfileIdScreenGetFilterOnDemand
      .map((e) =>
          customersCustomerIdProfilesProfileIdScreenGetFilterOnDemandFromJson(
              e.toString()))
      .toList();
}

List<enums.CustomersCustomerIdProfilesProfileIdScreenGetFilterOnDemand>?
    customersCustomerIdProfilesProfileIdScreenGetFilterOnDemandNullableListFromJson(
  List? customersCustomerIdProfilesProfileIdScreenGetFilterOnDemand, [
  List<enums.CustomersCustomerIdProfilesProfileIdScreenGetFilterOnDemand>?
      defaultValue,
]) {
  if (customersCustomerIdProfilesProfileIdScreenGetFilterOnDemand == null) {
    return defaultValue;
  }

  return customersCustomerIdProfilesProfileIdScreenGetFilterOnDemand
      .map((e) =>
          customersCustomerIdProfilesProfileIdScreenGetFilterOnDemandFromJson(
              e.toString()))
      .toList();
}

String? customersCustomerIdProfilesProfileIdASpotGetFilterOnDemandToJson(
    enums.CustomersCustomerIdProfilesProfileIdASpotGetFilterOnDemand?
        customersCustomerIdProfilesProfileIdASpotGetFilterOnDemand) {
  return customersCustomerIdProfilesProfileIdASpotGetFilterOnDemand?.value;
}

enums.CustomersCustomerIdProfilesProfileIdASpotGetFilterOnDemand
    customersCustomerIdProfilesProfileIdASpotGetFilterOnDemandFromJson(
  Object? customersCustomerIdProfilesProfileIdASpotGetFilterOnDemand, [
  enums.CustomersCustomerIdProfilesProfileIdASpotGetFilterOnDemand?
      defaultValue,
]) {
  return enums.CustomersCustomerIdProfilesProfileIdASpotGetFilterOnDemand.values
          .firstWhereOrNull((e) =>
              e.value ==
              customersCustomerIdProfilesProfileIdASpotGetFilterOnDemand) ??
      defaultValue ??
      enums.CustomersCustomerIdProfilesProfileIdASpotGetFilterOnDemand
          .swaggerGeneratedUnknown;
}

List<String>
    customersCustomerIdProfilesProfileIdASpotGetFilterOnDemandListToJson(
        List<enums.CustomersCustomerIdProfilesProfileIdASpotGetFilterOnDemand>?
            customersCustomerIdProfilesProfileIdASpotGetFilterOnDemand) {
  if (customersCustomerIdProfilesProfileIdASpotGetFilterOnDemand == null) {
    return [];
  }

  return customersCustomerIdProfilesProfileIdASpotGetFilterOnDemand
      .map((e) => e.value!)
      .toList();
}

List<enums.CustomersCustomerIdProfilesProfileIdASpotGetFilterOnDemand>
    customersCustomerIdProfilesProfileIdASpotGetFilterOnDemandListFromJson(
  List? customersCustomerIdProfilesProfileIdASpotGetFilterOnDemand, [
  List<enums.CustomersCustomerIdProfilesProfileIdASpotGetFilterOnDemand>?
      defaultValue,
]) {
  if (customersCustomerIdProfilesProfileIdASpotGetFilterOnDemand == null) {
    return defaultValue ?? [];
  }

  return customersCustomerIdProfilesProfileIdASpotGetFilterOnDemand
      .map((e) =>
          customersCustomerIdProfilesProfileIdASpotGetFilterOnDemandFromJson(
              e.toString()))
      .toList();
}

List<enums.CustomersCustomerIdProfilesProfileIdASpotGetFilterOnDemand>?
    customersCustomerIdProfilesProfileIdASpotGetFilterOnDemandNullableListFromJson(
  List? customersCustomerIdProfilesProfileIdASpotGetFilterOnDemand, [
  List<enums.CustomersCustomerIdProfilesProfileIdASpotGetFilterOnDemand>?
      defaultValue,
]) {
  if (customersCustomerIdProfilesProfileIdASpotGetFilterOnDemand == null) {
    return defaultValue;
  }

  return customersCustomerIdProfilesProfileIdASpotGetFilterOnDemand
      .map((e) =>
          customersCustomerIdProfilesProfileIdASpotGetFilterOnDemandFromJson(
              e.toString()))
      .toList();
}

String? customersCustomerIdProfilesProfileIdASpotsGetFilterOnDemandToJson(
    enums.CustomersCustomerIdProfilesProfileIdASpotsGetFilterOnDemand?
        customersCustomerIdProfilesProfileIdASpotsGetFilterOnDemand) {
  return customersCustomerIdProfilesProfileIdASpotsGetFilterOnDemand?.value;
}

enums.CustomersCustomerIdProfilesProfileIdASpotsGetFilterOnDemand
    customersCustomerIdProfilesProfileIdASpotsGetFilterOnDemandFromJson(
  Object? customersCustomerIdProfilesProfileIdASpotsGetFilterOnDemand, [
  enums.CustomersCustomerIdProfilesProfileIdASpotsGetFilterOnDemand?
      defaultValue,
]) {
  return enums
          .CustomersCustomerIdProfilesProfileIdASpotsGetFilterOnDemand.values
          .firstWhereOrNull((e) =>
              e.value ==
              customersCustomerIdProfilesProfileIdASpotsGetFilterOnDemand) ??
      defaultValue ??
      enums.CustomersCustomerIdProfilesProfileIdASpotsGetFilterOnDemand
          .swaggerGeneratedUnknown;
}

List<String>
    customersCustomerIdProfilesProfileIdASpotsGetFilterOnDemandListToJson(
        List<enums.CustomersCustomerIdProfilesProfileIdASpotsGetFilterOnDemand>?
            customersCustomerIdProfilesProfileIdASpotsGetFilterOnDemand) {
  if (customersCustomerIdProfilesProfileIdASpotsGetFilterOnDemand == null) {
    return [];
  }

  return customersCustomerIdProfilesProfileIdASpotsGetFilterOnDemand
      .map((e) => e.value!)
      .toList();
}

List<enums.CustomersCustomerIdProfilesProfileIdASpotsGetFilterOnDemand>
    customersCustomerIdProfilesProfileIdASpotsGetFilterOnDemandListFromJson(
  List? customersCustomerIdProfilesProfileIdASpotsGetFilterOnDemand, [
  List<enums.CustomersCustomerIdProfilesProfileIdASpotsGetFilterOnDemand>?
      defaultValue,
]) {
  if (customersCustomerIdProfilesProfileIdASpotsGetFilterOnDemand == null) {
    return defaultValue ?? [];
  }

  return customersCustomerIdProfilesProfileIdASpotsGetFilterOnDemand
      .map((e) =>
          customersCustomerIdProfilesProfileIdASpotsGetFilterOnDemandFromJson(
              e.toString()))
      .toList();
}

List<enums.CustomersCustomerIdProfilesProfileIdASpotsGetFilterOnDemand>?
    customersCustomerIdProfilesProfileIdASpotsGetFilterOnDemandNullableListFromJson(
  List? customersCustomerIdProfilesProfileIdASpotsGetFilterOnDemand, [
  List<enums.CustomersCustomerIdProfilesProfileIdASpotsGetFilterOnDemand>?
      defaultValue,
]) {
  if (customersCustomerIdProfilesProfileIdASpotsGetFilterOnDemand == null) {
    return defaultValue;
  }

  return customersCustomerIdProfilesProfileIdASpotsGetFilterOnDemand
      .map((e) =>
          customersCustomerIdProfilesProfileIdASpotsGetFilterOnDemandFromJson(
              e.toString()))
      .toList();
}

typedef $JsonFactory<T> = T Function(Map<String, dynamic> json);

class $CustomJsonDecoder {
  $CustomJsonDecoder(this.factories);

  final Map<Type, $JsonFactory> factories;

  dynamic decode<T>(dynamic entity) {
    if (entity is Iterable) {
      return _decodeList<T>(entity);
    }

    if (entity is T) {
      return entity;
    }

    if (isTypeOf<T, Map>()) {
      return entity;
    }

    if (isTypeOf<T, Iterable>()) {
      return entity;
    }

    if (entity is Map<String, dynamic>) {
      return _decodeMap<T>(entity);
    }

    return entity;
  }

  T _decodeMap<T>(Map<String, dynamic> values) {
    final jsonFactory = factories[T];
    if (jsonFactory == null || jsonFactory is! $JsonFactory<T>) {
      return throw "Could not find factory for type $T. Is '$T: $T.fromJsonFactory' included in the CustomJsonDecoder instance creation in bootstrapper.dart?";
    }

    return jsonFactory(values);
  }

  List<T> _decodeList<T>(Iterable values) =>
      values.where((v) => v != null).map<T>((v) => decode<T>(v) as T).toList();
}

class $JsonSerializableConverter extends chopper.JsonConverter {
  @override
  FutureOr<chopper.Response<ResultType>> convertResponse<ResultType, Item>(
      chopper.Response response) async {
    if (response.bodyString.isEmpty) {
      // In rare cases, when let's say 204 (no content) is returned -
      // we cannot decode the missing json with the result type specified
      return chopper.Response(response.base, null, error: response.error);
    }

    final jsonRes = await super.convertResponse(response);
    return jsonRes.copyWith<ResultType>(
        body: $jsonDecoder.decode<Item>(jsonRes.body) as ResultType);
  }
}

final $jsonDecoder = $CustomJsonDecoder(generatedMapping);

// ignore: unused_element
String? _dateToJson(DateTime? date) {
  if (date == null) {
    return null;
  }

  final year = date.year.toString();
  final month = date.month < 10 ? '0${date.month}' : date.month.toString();
  final day = date.day < 10 ? '0${date.day}' : date.day.toString();

  return '$year-$month-$day';
}

class Wrapped<T> {
  final T value;
  const Wrapped.value(this.value);
}
