import 'package:json_annotation/json_annotation.dart';
import 'package:collection/collection.dart';

enum VodResponseType {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('Transaction')
  transaction('Transaction'),
  @JsonValue('Subscription')
  subscription('Subscription');

  final String? value;

  const VodResponseType(this.value);
}

enum VodResponseEntitlementState {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('entitled')
  entitled('entitled'),
  @JsonValue('notentitled')
  notentitled('notentitled');

  final String? value;

  const VodResponseEntitlementState(this.value);
}

enum ViewProgressResponseViewState {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('partially-watched')
  partiallyWatched('partially-watched'),
  @JsonValue('fully-watched')
  fullyWatched('fully-watched');

  final String? value;

  const ViewProgressResponseViewState(this.value);
}

enum SourceTypeResponse {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('Linear')
  linear('Linear'),
  @JsonValue('VOD')
  vod('VOD'),
  @JsonValue('OTT')
  ott('OTT'),
  @JsonValue('Recording')
  recording('Recording');

  final String? value;

  const SourceTypeResponse(this.value);
}

enum RecordingSourceResponseRecordingState {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('planned')
  planned('planned'),
  @JsonValue('ongoing')
  ongoing('ongoing'),
  @JsonValue('recorded')
  recorded('recorded'),
  @JsonValue('failed')
  failed('failed'),
  @JsonValue('blackout')
  blackout('blackout'),
  @JsonValue('partiallyRecorded')
  partiallyrecorded('partiallyRecorded'),
  @JsonValue('quotaExceeded')
  quotaexceeded('quotaExceeded'),
  @JsonValue('replaced')
  replaced('replaced'),
  @JsonValue('cancelled')
  cancelled('cancelled');

  final String? value;

  const RecordingSourceResponseRecordingState(this.value);
}

enum VodSourceResponseType {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('Subscription')
  subscription('Subscription'),
  @JsonValue('Transaction')
  transaction('Transaction');

  final String? value;

  const VodSourceResponseType(this.value);
}

enum EpisodePickerVodSourceResponseType {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('Subscription')
  subscription('Subscription'),
  @JsonValue('Transaction')
  transaction('Transaction');

  final String? value;

  const EpisodePickerVodSourceResponseType(this.value);
}

enum EpisodePickerEpisodeResponseType {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('Episode')
  episode('Episode'),
  @JsonValue('Special')
  special('Special');

  final String? value;

  const EpisodePickerEpisodeResponseType(this.value);
}

enum SaaoSourceResponseContentType {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('VOD')
  vod('VOD'),
  @JsonValue('Linear')
  linear('Linear');

  final String? value;

  const SaaoSourceResponseContentType(this.value);
}

enum LinearContentSourceType {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('VOD')
  vod('VOD'),
  @JsonValue('OTT')
  ott('OTT'),
  @JsonValue('Linear')
  linear('Linear'),
  @JsonValue('Recording')
  recording('Recording');

  final String? value;

  const LinearContentSourceType(this.value);
}

enum MaxRes {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('sd')
  sd('sd'),
  @JsonValue('hd')
  hd('hd'),
  @JsonValue('4K')
  value_4k('4K'),
  @JsonValue('5K')
  value_5k('5K'),
  @JsonValue('8K')
  value_8k('8K');

  final String? value;

  const MaxRes(this.value);
}

enum FilterOnDemand {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('svod')
  svod('svod');

  final String? value;

  const FilterOnDemand(this.value);
}

enum V1RecordingSourcesTypeCridLanguageGetType {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('title')
  title('title'),
  @JsonValue('series')
  series('series');

  final String? value;

  const V1RecordingSourcesTypeCridLanguageGetType(this.value);
}

enum MostRelevantEpisodeResponse$ResponseContentType {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('vod')
  vod('vod'),
  @JsonValue('linear')
  linear('linear'),
  @JsonValue('replay')
  replay('replay'),
  @JsonValue('recording')
  recording('recording');

  final String? value;

  const MostRelevantEpisodeResponse$ResponseContentType(this.value);
}

enum MostRelevantSourceResponse$ResponseContentType {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('vod')
  vod('vod'),
  @JsonValue('linear')
  linear('linear'),
  @JsonValue('replay')
  replay('replay'),
  @JsonValue('recording')
  recording('recording');

  final String? value;

  const MostRelevantSourceResponse$ResponseContentType(this.value);
}

enum MostRelevantEpisodeBulk$RequestBodyMaxRes {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('sd')
  sd('sd'),
  @JsonValue('hd')
  hd('hd'),
  @JsonValue('4K')
  value_4k('4K'),
  @JsonValue('5K')
  value_5k('5K'),
  @JsonValue('8K')
  value_8k('8K');

  final String? value;

  const MostRelevantEpisodeBulk$RequestBodyMaxRes(this.value);
}

enum MostRelevantEpisodeBulk$RequestBodyFilterOnDemand {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('svod')
  svod('svod');

  final String? value;

  const MostRelevantEpisodeBulk$RequestBodyFilterOnDemand(this.value);
}
