import 'package:json_annotation/json_annotation.dart';
import 'package:collection/collection.dart';

enum RecordingState {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('recorded')
  recorded('recorded'),
  @JsonValue('partiallyRecorded')
  partiallyrecorded('partiallyRecorded'),
  @JsonValue('planned')
  planned('planned'),
  @JsonValue('ongoing')
  ongoing('ongoing'),
  @JsonValue('failed')
  failed('failed'),
  @JsonValue('blackedOut')
  blackedout('blackedOut'),
  @JsonValue('quotaExceeded')
  quotaexceeded('quotaExceeded'),
  @JsonValue('bookingPending')
  bookingpending('bookingPending'),
  @JsonValue('cancelled')
  cancelled('cancelled');

  final String? value;

  const RecordingState(this.value);
}

enum RecordingType {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('nDVR')
  ndvr('nDVR'),
  @JsonValue('LDVR')
  ldvr('LDVR');

  final String? value;

  const RecordingType(this.value);
}

enum ExpansionType {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('fromThisSeason')
  fromthisseason('fromThisSeason'),
  @JsonValue('fromThisEpisode')
  fromthisepisode('fromThisEpisode'),
  @JsonValue('wholeShow')
  wholeshow('wholeShow'),
  @JsonValue('onlyThisSeason')
  onlythisseason('onlyThisSeason'),
  @JsonValue('premiere')
  premiere('premiere');

  final String? value;

  const ExpansionType(this.value);
}

enum ItemType {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('single')
  single('single'),
  @JsonValue('season')
  season('season'),
  @JsonValue('show')
  show('show');

  final String? value;

  const ItemType(this.value);
}

enum AssetizationStatus {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('pending')
  pending('pending'),
  @JsonValue('inProcess')
  inprocess('inProcess'),
  @JsonValue('completed')
  completed('completed'),
  @JsonValue('failed')
  failed('failed');

  final String? value;

  const AssetizationStatus(this.value);
}

enum FailureReason {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('USER_ACTION')
  userAction('USER_ACTION'),
  @JsonValue('NOT_IN_REVIEW_BUFFER')
  notInReviewBuffer('NOT_IN_REVIEW_BUFFER'),
  @JsonValue('DISK_FULL')
  diskFull('DISK_FULL'),
  @JsonValue('NO_ENTITLEMENT')
  noEntitlement('NO_ENTITLEMENT'),
  @JsonValue('POWER_CUT')
  powerCut('POWER_CUT'),
  @JsonValue('MANUAL_CONFLICT_RESOLUTION')
  manualConflictResolution('MANUAL_CONFLICT_RESOLUTION'),
  @JsonValue('AUTO_CONFLICT_RESOLUTION')
  autoConflictResolution('AUTO_CONFLICT_RESOLUTION'),
  @JsonValue('SIGNAL_LOSS')
  signalLoss('SIGNAL_LOSS'),
  @JsonValue('EPG_UPDATE')
  epgUpdate('EPG_UPDATE'),
  @JsonValue('CHANNEL_LINEUP_CHANGE')
  channelLineupChange('CHANNEL_LINEUP_CHANGE'),
  @JsonValue('INTERNAL_ERROR')
  internalError('INTERNAL_ERROR'),
  @JsonValue('CHANNEL_OFF_AIR')
  channelOffAir('CHANNEL_OFF_AIR'),
  @JsonValue('BLACKOUT')
  blackout('BLACKOUT'),
  @JsonValue('QUOTA_EXCEEDED')
  quotaExceeded('QUOTA_EXCEEDED');

  final String? value;

  const FailureReason(this.value);
}

enum Source {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('single')
  single('single'),
  @JsonValue('show')
  show('show');

  final String? value;

  const Source(this.value);
}

enum RecordingsKind {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('bookings')
  bookings('bookings'),
  @JsonValue('recordings')
  recordings('recordings');

  final String? value;

  const RecordingsKind(this.value);
}

enum Recordings$ItemType {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('abr')
  abr('abr'),
  @JsonValue('cbr')
  cbr('cbr');

  final String? value;

  const Recordings$ItemType(this.value);
}

enum OpWithNetworkRecordingsOp {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('update')
  update('update');

  final String? value;

  const OpWithNetworkRecordingsOp(this.value);
}

enum Op {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('update')
  update('update'),
  @JsonValue('delete')
  delete('delete');

  final String? value;

  const Op(this.value);
}

enum CustomersCustomerIdRecordingsGetMostRelevantEpisodeFor {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('bookings')
  bookings('bookings'),
  @JsonValue('recordings')
  recordings('recordings');

  final String? value;

  const CustomersCustomerIdRecordingsGetMostRelevantEpisodeFor(this.value);
}

enum CustomersCustomerIdRecordingsGetRecordingsKind {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('bookings')
  bookings('bookings'),
  @JsonValue('recordings')
  recordings('recordings');

  final String? value;

  const CustomersCustomerIdRecordingsGetRecordingsKind(this.value);
}

enum CustomersCustomerIdRecordingsGetSort {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('time')
  time('time'),
  @JsonValue('title')
  title('title'),
  @JsonValue('episode')
  episode('episode'),
  @JsonValue('diskSpace')
  diskspace('diskSpace');

  final String? value;

  const CustomersCustomerIdRecordingsGetSort(this.value);
}

enum CustomersCustomerIdRecordingsGetSortOrder {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('asc')
  asc('asc'),
  @JsonValue('desc')
  desc('desc');

  final String? value;

  const CustomersCustomerIdRecordingsGetSortOrder(this.value);
}

enum CustomersCustomerIdRecordingsShowGetRecordingType {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('nDVR')
  ndvr('nDVR'),
  @JsonValue('LDVR')
  ldvr('LDVR');

  final String? value;

  const CustomersCustomerIdRecordingsShowGetRecordingType(this.value);
}
