import 'package:json_annotation/json_annotation.dart';
import 'package:collection/collection.dart';

enum SourceType {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('single')
  single('single'),
  @JsonValue('show')
  show('show');

  final String? value;

  const SourceType(this.value);
}

enum ItemType {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('single')
  single('single'),
  @JsonValue('season')
  season('season'),
  @JsonValue('show')
  show('show');

  final String? value;

  const ItemType(this.value);
}

enum RecordingState {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('planned')
  planned('planned'),
  @JsonValue('ongoing')
  ongoing('ongoing'),
  @JsonValue('recorded')
  recorded('recorded'),
  @JsonValue('failed')
  failed('failed'),
  @JsonValue('blackout')
  blackout('blackout'),
  @JsonValue('partiallyRecorded')
  partiallyrecorded('partiallyRecorded'),
  @JsonValue('quotaExceeded')
  quotaexceeded('quotaExceeded'),
  @JsonValue('replaced')
  replaced('replaced'),
  @JsonValue('cancelled')
  cancelled('cancelled');

  final String? value;

  const RecordingState(this.value);
}

enum RecordingStatePending {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('planned')
  planned('planned'),
  @JsonValue('ongoing')
  ongoing('ongoing'),
  @JsonValue('recorded')
  recorded('recorded'),
  @JsonValue('failed')
  failed('failed'),
  @JsonValue('blackout')
  blackout('blackout'),
  @JsonValue('partiallyRecorded')
  partiallyrecorded('partiallyRecorded'),
  @JsonValue('quotaExceeded')
  quotaexceeded('quotaExceeded'),
  @JsonValue('replaced')
  replaced('replaced'),
  @JsonValue('bookingPending')
  bookingpending('bookingPending');

  final String? value;

  const RecordingStatePending(this.value);
}

enum ViewState {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('notWatched')
  notwatched('notWatched'),
  @JsonValue('partiallyWatched')
  partiallywatched('partiallyWatched'),
  @JsonValue('alreadyWatched')
  alreadywatched('alreadyWatched');

  final String? value;

  const ViewState(this.value);
}

enum ImageType {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('HighResLandscape')
  highreslandscape('HighResLandscape'),
  @JsonValue('HighResPortrait')
  highresportrait('HighResPortrait'),
  @JsonValue('BoxCover')
  boxcover('BoxCover'),
  @JsonValue('TitleTreatment')
  titletreatment('TitleTreatment'),
  @JsonValue('HighResLandscapeProductionStill')
  highreslandscapeproductionstill('HighResLandscapeProductionStill');

  final String? value;

  const ImageType(this.value);
}

enum EpisodeImageType {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('seasonPoster')
  seasonposter('seasonPoster'),
  @JsonValue('showPoster')
  showposter('showPoster'),
  @JsonValue('episodePoster')
  episodeposter('episodePoster'),
  @JsonValue('eosShowPoster')
  eosshowposter('eosShowPoster'),
  @JsonValue('titleTreatment')
  titletreatment('titleTreatment');

  final String? value;

  const EpisodeImageType(this.value);
}

enum TileBookingRecordingState {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('planned')
  planned('planned'),
  @JsonValue('ongoing')
  ongoing('ongoing'),
  @JsonValue('recorded')
  recorded('recorded'),
  @JsonValue('failed')
  failed('failed'),
  @JsonValue('blackout')
  blackout('blackout'),
  @JsonValue('partiallyRecorded')
  partiallyrecorded('partiallyRecorded'),
  @JsonValue('quotaExceeded')
  quotaexceeded('quotaExceeded'),
  @JsonValue('replaced')
  replaced('replaced'),
  @JsonValue('cancelled')
  cancelled('cancelled');

  final String? value;

  const TileBookingRecordingState(this.value);
}

enum TileBookingType {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('single')
  single('single'),
  @JsonValue('show')
  show('show'),
  @JsonValue('season')
  season('season');

  final String? value;

  const TileBookingType(this.value);
}

enum ContextualRecordingRecordingState {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('planned')
  planned('planned'),
  @JsonValue('ongoing')
  ongoing('ongoing'),
  @JsonValue('recorded')
  recorded('recorded'),
  @JsonValue('failed')
  failed('failed'),
  @JsonValue('blackout')
  blackout('blackout'),
  @JsonValue('partiallyRecorded')
  partiallyrecorded('partiallyRecorded'),
  @JsonValue('quotaExceeded')
  quotaexceeded('quotaExceeded'),
  @JsonValue('replaced')
  replaced('replaced'),
  @JsonValue('cancelled')
  cancelled('cancelled');

  final String? value;

  const ContextualRecordingRecordingState(this.value);
}

enum ContextualRecordingType {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('single')
  single('single'),
  @JsonValue('season')
  season('season'),
  @JsonValue('show')
  show('show');

  final String? value;

  const ContextualRecordingType(this.value);
}

enum TileRecordingRecordingState {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('planned')
  planned('planned'),
  @JsonValue('ongoing')
  ongoing('ongoing'),
  @JsonValue('recorded')
  recorded('recorded'),
  @JsonValue('failed')
  failed('failed'),
  @JsonValue('blackout')
  blackout('blackout'),
  @JsonValue('partiallyRecorded')
  partiallyrecorded('partiallyRecorded'),
  @JsonValue('quotaExceeded')
  quotaexceeded('quotaExceeded'),
  @JsonValue('replaced')
  replaced('replaced'),
  @JsonValue('cancelled')
  cancelled('cancelled');

  final String? value;

  const TileRecordingRecordingState(this.value);
}

enum TileRecordingType {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('single')
  single('single'),
  @JsonValue('season')
  season('season'),
  @JsonValue('show')
  show('show');

  final String? value;

  const TileRecordingType(this.value);
}

enum RecordingType {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('nDVR')
  ndvr('nDVR'),
  @JsonValue('LDVR')
  ldvr('LDVR');

  final String? value;

  const RecordingType(this.value);
}

enum Op {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('update')
  update('update');

  final String? value;

  const Op(this.value);
}

enum ExpansionType {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('fromThisSeason')
  fromthisseason('fromThisSeason'),
  @JsonValue('fromThisEpisode')
  fromthisepisode('fromThisEpisode'),
  @JsonValue('wholeShow')
  wholeshow('wholeShow'),
  @JsonValue('onlyThisSeason')
  onlythisseason('onlyThisSeason'),
  @JsonValue('premiere')
  premiere('premiere');

  final String? value;

  const ExpansionType(this.value);
}

enum FailureReason {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('USER_ACTION')
  userAction('USER_ACTION'),
  @JsonValue('NOT_IN_REVIEW_BUFFER')
  notInReviewBuffer('NOT_IN_REVIEW_BUFFER'),
  @JsonValue('DISK_FULL')
  diskFull('DISK_FULL'),
  @JsonValue('NO_ENTITLEMENT')
  noEntitlement('NO_ENTITLEMENT'),
  @JsonValue('POWER_CUT')
  powerCut('POWER_CUT'),
  @JsonValue('MANUAL_CONFLICT_RESOLUTION')
  manualConflictResolution('MANUAL_CONFLICT_RESOLUTION'),
  @JsonValue('AUTO_CONFLICT_RESOLUTION')
  autoConflictResolution('AUTO_CONFLICT_RESOLUTION'),
  @JsonValue('SIGNAL_LOSS')
  signalLoss('SIGNAL_LOSS'),
  @JsonValue('EPG_UPDATE')
  epgUpdate('EPG_UPDATE'),
  @JsonValue('CHANNEL_LINEUP_CHANGE')
  channelLineupChange('CHANNEL_LINEUP_CHANGE'),
  @JsonValue('INTERNAL_ERROR')
  internalError('INTERNAL_ERROR'),
  @JsonValue('CHANNEL_OFF_AIR')
  channelOffAir('CHANNEL_OFF_AIR'),
  @JsonValue('QUOTA_EXCEEDED')
  quotaExceeded('QUOTA_EXCEEDED');

  final String? value;

  const FailureReason(this.value);
}

enum CustomersCustomerIdBookingsGetSort {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('time')
  time('time'),
  @JsonValue('title')
  title('title');

  final String? value;

  const CustomersCustomerIdBookingsGetSort(this.value);
}

enum CustomersCustomerIdBookingsGetSortOrder {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('asc')
  asc('asc'),
  @JsonValue('desc')
  desc('desc');

  final String? value;

  const CustomersCustomerIdBookingsGetSortOrder(this.value);
}

enum CustomersCustomerIdRecordingsGetSort {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('time')
  time('time'),
  @JsonValue('title')
  title('title'),
  @JsonValue('diskSpace')
  diskspace('diskSpace');

  final String? value;

  const CustomersCustomerIdRecordingsGetSort(this.value);
}

enum CustomersCustomerIdRecordingsGetSortOrder {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('asc')
  asc('asc'),
  @JsonValue('desc')
  desc('desc');

  final String? value;

  const CustomersCustomerIdRecordingsGetSortOrder(this.value);
}

enum CustomersCustomerIdRecordingsSimpleGetStatus {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('planned')
  planned('planned'),
  @JsonValue('recorded')
  recorded('recorded');

  final String? value;

  const CustomersCustomerIdRecordingsSimpleGetStatus(this.value);
}

enum CustomersCustomerIdEpisodesSeasonsSeasonIdGetSource {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('booking')
  booking('booking'),
  @JsonValue('recording')
  recording('recording');

  final String? value;

  const CustomersCustomerIdEpisodesSeasonsSeasonIdGetSource(this.value);
}

enum CustomersCustomerIdEpisodesSeasonsSeasonIdGetSort {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('time')
  time('time'),
  @JsonValue('title')
  title('title'),
  @JsonValue('episode')
  episode('episode');

  final String? value;

  const CustomersCustomerIdEpisodesSeasonsSeasonIdGetSort(this.value);
}

enum CustomersCustomerIdEpisodesSeasonsSeasonIdGetSortOrder {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('asc')
  asc('asc'),
  @JsonValue('desc')
  desc('desc');

  final String? value;

  const CustomersCustomerIdEpisodesSeasonsSeasonIdGetSortOrder(this.value);
}

enum CustomersCustomerIdEpisodesShowsShowIdGetSource {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('booking')
  booking('booking'),
  @JsonValue('recording')
  recording('recording');

  final String? value;

  const CustomersCustomerIdEpisodesShowsShowIdGetSource(this.value);
}

enum CustomersCustomerIdEpisodesShowsShowIdGetSort {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('time')
  time('time'),
  @JsonValue('title')
  title('title'),
  @JsonValue('episode')
  episode('episode');

  final String? value;

  const CustomersCustomerIdEpisodesShowsShowIdGetSort(this.value);
}

enum CustomersCustomerIdEpisodesShowsShowIdGetSortOrder {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('asc')
  asc('asc'),
  @JsonValue('desc')
  desc('desc');

  final String? value;

  const CustomersCustomerIdEpisodesShowsShowIdGetSortOrder(this.value);
}

enum DiscoveryServiceCustomersCustomerIdRecordingsSimpleGetStatus {
  @JsonValue(null)
  swaggerGeneratedUnknown(null),

  @JsonValue('planned')
  planned('planned'),
  @JsonValue('recorded')
  recorded('recorded');

  final String? value;

  const DiscoveryServiceCustomersCustomerIdRecordingsSimpleGetStatus(
      this.value);
}
